/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor.c
 *
 * Project:
 * --------
 *   Maui_sw
 *
 * Description:
 * ------------
 *   Image sensor driver function
 *
 * Author:
 * -------
 * -------
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#include "kal_non_specific_general_types.h"
#include "kal_release.h"
#include "kal_trace.h"
#include "stack_config.h"
#include "stdio.h"
#include "string.h"
#include "drv_features.h"
#include "upll_ctrl.h"
#include "med_api.h"
#include "isp_if.h"
#include "camera_para.h"
#include "sensor_common_interface.h"
#include "sensor_struct.h"
#include "image_sensor.h"
#include "sensor_common.h"
#include "image_sensor_SP0827_SERIAL.h"
#ifndef SP0827_SERIAL_HW_SCCB
#include "sccb.h"
#else
#include "sccb_v2.h"
#include "sccb_v2_custom.h"
#endif

#if (defined(__SENSOR_FRAME_RATE_SUPPORT__))
#include "sensor_frame_rate_lut.h"
#endif

#define SP0827_SERIAL_SPI_CLOCK_PIN                          59
#define SP0827_SERIAL_SPI_DATA_PIN                            47
#define SP0827_SERIAL_POWERDOWN_PIN                           57
#define SP0827_SERIAL_I2C_CLOCK_PIN                          22
#define SP0827_SERIAL_I2C_DATA_PIN                          23

#define  SP0827_DAYLIGHT_MAXGAIN             0x70
#define  SP0827_NIGHT_MAXGAIN                   0xa0
#define __DUAL_Camera_SP0827__ // SP0827 use to Sub_Camera 

static kal_bool SP0827_SERIAL_g_bNightMode = KAL_FALSE;
static kal_uint8 SP0827_SERIAL_g_iBanding = CAM_BANDING_50HZ;
static kal_bool SP0827_SERIAL_Video_Mode = KAL_FALSE;

SEC_SENSOR_SET_PARA_STRUCT SP0827_sensor_para_set;



extern void yuv_wait_one_vd_done(void);
#ifdef SP0827_SERIAL_HW_SCCB
extern void i2c_set_get_handle_wait(SCCB_OWNER owner,kal_bool enable);
extern void i2c_set_slave_address(SCCB_OWNER owner,kal_uint8 slave_address);
extern kal_uint32 i2c_set_transaction_mode(SCCB_OWNER owner,SCCB_TRANSACTION_MODE mode,SCCB_SPEED_ENUM speed);
#endif

#ifndef SP0827_SERIAL_HW_SCCB
/*************************************************************************
* FUNCTION
*    SP0827_SERIAL_SCCB_send_byte
*
* DESCRIPTION
*    This function send data to I2C
*
* PARAMETERS
*    send_byte    : 8bit data send to I2C
*
* RETURNS
*    1    : send fail
*    0    : send success
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint8 SP0827_SERIAL_SCCB_send_byte(kal_uint8 send_byte)
{
  volatile signed char i;
  volatile kal_uint32 j;
  kal_uint8 ack;
  for (i = 7; i >= 0; i--)
  {
    if (send_byte&(1 << i))
    {
    // SET_SCCB_DATA_HIGH;
	  GPIO_WriteIO(1,SP0827_SERIAL_I2C_DATA_PIN);
    }
    else
    {
     // SET_SCCB_DATA_LOW;
	  GPIO_WriteIO(0,SP0827_SERIAL_I2C_DATA_PIN);
    }
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
 //   SET_SCCB_CLK_HIGH;
   GPIO_WriteIO(1,SP0827_SERIAL_I2C_CLOCK_PIN);
 //GPIO_WriteIO_FAST(1,SCCB_SERIAL_SW_CLK_PIN);
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
   // SET_SCCB_DATA_OUTPUT; /* only for delay */
   GPIO_InitIO(1,SP0827_SERIAL_I2C_DATA_PIN);
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
  //  SET_SCCB_CLK_LOW;
   GPIO_WriteIO(0,SP0827_SERIAL_I2C_CLOCK_PIN);
//GPIO_WriteIO_FAST(0,SCCB_SERIAL_SW_CLK_PIN);
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
  }
 // SET_SCCB_DATA_INPUT;
  GPIO_InitIO(0,SP0827_SERIAL_I2C_DATA_PIN);
  for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
// SET_SCCB_CLK_HIGH;
 GPIO_WriteIO(1,SP0827_SERIAL_I2C_CLOCK_PIN);
//GPIO_WriteIO_FAST(1,SCCB_SERIAL_SW_CLK_PIN);
  for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
 // ack = GET_SCCB_DATA_BIT;
 ack = GPIO_ReadIO(SP0827_SERIAL_I2C_DATA_PIN);
  for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
//  SET_SCCB_CLK_LOW;
  GPIO_WriteIO(0,SP0827_SERIAL_I2C_CLOCK_PIN);
//GPIO_WriteIO_FAST(0,SCCB_SERIAL_SW_CLK_PIN);
  for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
 // SET_SCCB_DATA_OUTPUT;
  GPIO_InitIO(1,SP0827_SERIAL_I2C_DATA_PIN);
  
  return ack;
}

/*************************************************************************
* FUNCTION
*    SP0827_SERIAL_SCCB_get_byte
*
* DESCRIPTION
*    This function read 8bit data from I2C
*
* PARAMETERS
*    None
*
* RETURNS
*    8bit data read from I2C
*
* GLOBALS AFFECTED
*
*************************************************************************/

static kal_uint8 SP0827_SERIAL_SCCB_get_byte(void)
{
  volatile signed char i;
  volatile kal_uint32 j;
  kal_uint8 get_byte = 0;
  
  for (i = 7; i >= 0; i--)
  {
    GPIO_InitIO(0,SP0827_SERIAL_I2C_DATA_PIN);
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
    GPIO_WriteIO(1,SP0827_SERIAL_I2C_CLOCK_PIN);
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
    if (GPIO_ReadIO(SP0827_SERIAL_I2C_DATA_PIN)) get_byte |= (1 << i);
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
    GPIO_WriteIO(0,SP0827_SERIAL_I2C_CLOCK_PIN);
    for (j = 0; j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
  }
  GPIO_WriteIO(1,SP0827_SERIAL_I2C_DATA_PIN);
  GPIO_InitIO(1,SP0827_SERIAL_I2C_DATA_PIN);
  for (j = 0;j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
  GPIO_WriteIO(1,SP0827_SERIAL_I2C_CLOCK_PIN);
  for (j = 0;j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
  GPIO_InitIO(1,SP0827_SERIAL_I2C_DATA_PIN); /* only for delay */
  for (j = 0;j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
  GPIO_WriteIO(0,SP0827_SERIAL_I2C_CLOCK_PIN);
  for (j = 0;j < SP0827_SERIAL_SENSOR_I2C_DELAY; j++);
  
  return get_byte;
}
#endif

/*************************************************************************
* FUNCTION
*    SP0827_SERIAL_write_cmos_sensor
*
* DESCRIPTION
*    This function wirte data to CMOS sensor through I2C
*    SP0827_SERIAL_MAX_I2C_FAIL_TRY_NO is the max try number. when write fail, the function retry again until
*    try times reach SP0827_SERIAL_MAX_I2C_FAIL_TRY_NO.
*
* PARAMETERS
*    addr    : the 8bit address of register
*    para    : the 8bit value of register
*
* RETURNS
*    None
*
* GLOBALS AFFECTED
*
*************************************************************************/
 void SP0827_SERIAL_I2C_START(void)
{ 
	int j;
		GPIO_InitIO(1,SP0827_SERIAL_I2C_CLOCK_PIN); 
		GPIO_InitIO(1,SP0827_SERIAL_I2C_DATA_PIN); 
		GPIO_WriteIO(1,SP0827_SERIAL_I2C_DATA_PIN);
		
        for (j = SP0827_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); 
		GPIO_WriteIO(1,SP0827_SERIAL_I2C_CLOCK_PIN);
        for (j = SP0827_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); 
		GPIO_WriteIO(0,SP0827_SERIAL_I2C_DATA_PIN);
        for (j = SP0827_SERIAL_SENSOR_I2C_DELAY; j > 0; j--);
		GPIO_WriteIO(0,SP0827_SERIAL_I2C_CLOCK_PIN);
        for (j = SP0827_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); 
}
 void SP0827_SERIAL_I2C_END(void)
{
	int j;
		GPIO_InitIO(1,SP0827_SERIAL_I2C_CLOCK_PIN); 
		GPIO_InitIO(1,SP0827_SERIAL_I2C_DATA_PIN); 
		GPIO_WriteIO(0,SP0827_SERIAL_I2C_CLOCK_PIN);
		GPIO_WriteIO(0,SP0827_SERIAL_I2C_DATA_PIN);
        for (j = SP0827_SERIAL_SENSOR_I2C_DELAY; j > 0; j--);
		GPIO_WriteIO(1,SP0827_SERIAL_I2C_CLOCK_PIN);
        for (j = SP0827_SERIAL_SENSOR_I2C_DELAY; j > 0; j--);
		GPIO_WriteIO(1,SP0827_SERIAL_I2C_DATA_PIN);
}


static void SP0827_SERIAL_write_cmos_sensor(kal_uint8 addr, kal_uint8 para)
{
#ifndef SP0827_SERIAL_HW_SCCB
  kal_uint8 fail_try_no = SP0827_SERIAL_MAX_I2C_FAIL_TRY_NO + 1;
  while (--fail_try_no > 0)
  {
 	SP0827_SERIAL_I2C_START();
    if (SP0827_SERIAL_SCCB_send_byte(SP0827_SERIAL_I2C_WRITE_ID)) continue;
    if (SP0827_SERIAL_SCCB_send_byte(addr)) continue;
    if (SP0827_SERIAL_SCCB_send_byte(para)) continue;
    break;
  }
 SP0827_SERIAL_I2C_END();

#else
  SCCB_TRANSACTION_RESULT rt;
  kal_uint8 out_buff[2];

  i2c_set_get_handle_wait(SCCB_OWNER_CAMERA, KAL_TRUE);
  i2c_set_slave_address(SCCB_OWNER_CAMERA, SP0827_SERIAL_I2C_WRITE_ID);
  i2c_set_transaction_mode(SCCB_OWNER_CAMERA, SCCB_TRANSACTION_FAST_MODE, SCCB_100KB);
  
  out_buff[0] = addr;
  out_buff[1] = para;
  rt = i2c_write(SCCB_OWNER_CAMERA, out_buff, sizeof(out_buff));

#endif
}
/*************************************************************************
* FUNCTION
*    SP0827_SERIAL_read_cmos_sensor
*
* DESCRIPTION
*    This function read data from CMOS sensor through I2C.
*    SP0827_SERIAL_MAX_I2C_FAIL_TRY_NO is the max try number. when read fail, the function retry again until
*    try times reach SP0827_SERIAL_MAX_I2C_FAIL_TRY_NO.
*
* PARAMETERS
*    addr    : the 8bit address of register
*
* RETURNS
*    8bit data read through I2C
*
* GLOBALS AFFECTED
*
*************************************************************************/


 kal_uint8 SP0827_SERIAL_read_cmos_sensor(kal_uint8 addr)
{
#ifndef SP0827_SERIAL_HW_SCCB

  kal_uint8 get_byte = 0xFF;
  kal_uint8 fail_try_no = SP0827_SERIAL_MAX_I2C_FAIL_TRY_NO + 1;
  
  while (--fail_try_no > 0)
  {
	SP0827_SERIAL_I2C_START();
    if (SP0827_SERIAL_SCCB_send_byte(SP0827_SERIAL_I2C_WRITE_ID)) continue;
    if (SP0827_SERIAL_SCCB_send_byte(addr)) continue;
	SP0827_SERIAL_I2C_START();
    if (SP0827_SERIAL_SCCB_send_byte(SP0827_SERIAL_I2C_READ_ID)) continue;
    get_byte = SP0827_SERIAL_SCCB_get_byte();
    break;
  }
  SP0827_SERIAL_I2C_END();
 
  return get_byte;

#else

  SCCB_TRANSACTION_RESULT rt;
  kal_uint8 in_buff[1] = {0xFF};
  kal_uint8 out_buff[1];

  i2c_set_get_handle_wait(SCCB_OWNER_CAMERA, KAL_TRUE);
  i2c_set_slave_address(SCCB_OWNER_CAMERA, SP0827_SERIAL_I2C_WRITE_ID);
  i2c_set_transaction_mode(SCCB_OWNER_CAMERA, SCCB_TRANSACTION_FAST_MODE, SCCB_100KB);
  
  out_buff[0] = addr;
  rt = i2c_write_and_read(SCCB_OWNER_CAMERA, out_buff, sizeof(out_buff), in_buff, sizeof(in_buff));

  return in_buff[0];
	
#endif
}

/*****************************************************************************
 * FUNCTION
 *  SP0827_SERIAL_PowerOn
 * DESCRIPTION
 *  This function Power On the CMOS sensor .
 * PARAMETERS
 *  void
 * RETURNS
 *  void
 *****************************************************************************/
static kal_int16 SP0827_SERIAL_PowerOn(void)
{
    kal_uint16 sensor_id = 0;
    int i,tmp;

    /* PowerOn the sensor */
    cis_module_power_on(KAL_TRUE);	
    kal_sleep_task(2);  /* delay for power stable */

    /* set sensors chip enable pin to high to activate SP0827_SERIAL */
    SP0827_SERIAL_PWRDN_PIN_HIGH;
       kal_sleep_task(10); 	
	SP0827_SERIAL_PWRDN_PIN_LOW;
    set_isp_driving_current(ISP_DRIVING_6MA);

	#if 1

	ENABLE_CAMERA_TG_CLK_48M;				/* 48Mhz Clock Base */
		UPLL_Enable(UPLL_OWNER_ISP);
		/* Set MCLK Divider, The MCLK = 52 / (1+1) Mhz, or 48  / (1+1) Mhz based on the Clock Base above */
		SET_TG_OUTPUT_CLK_DIVIDER(1);
		SET_CMOS_RISING_EDGE(0);			/* Always set the Rising_Edge = 0 */
		SET_CMOS_FALLING_EDGE(1);			/* Set the Falling_Edge = ((TG_CLK_DIVIDER + 1) / 2) to get 50% duty of MCLK. */


#else
    /* SP0827_SERIAL needs 24M MCLK */
    /* Use UPLL to produce 48M clock, then divided by 2 */
#if (defined(DRV_ISP_6238_SERIES))
    setCameraCPLLOutputFreq(48000000);
    ENABLE_CAMERA_TG_CLK_48M;
#else
    DISABLE_CAMERA_TG_CLK_48M;

    #if !defined(SP0827_52Mhz_24FPS)
    ENABLE_CAMERA_TG_CLK_48M;
    #endif
    UPLL_Enable(UPLL_OWNER_ISP);
#endif
    SET_TG_OUTPUT_CLK_DIVIDER(2);//48Mhz/2=24M
    SET_CMOS_RISING_EDGE(0);
    SET_CMOS_FALLING_EDGE(0);
#endif
    /* Sensor Signal Polarity */
    /* Note: Set HSync Polarity to Low means High active */
    ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
    ENABLE_CAMERA_PIXEL_CLK_INV;
    SET_CMOS_CLOCK_POLARITY_LOW;
    SET_VSYNC_POLARITY_LOW;
    SET_HSYNC_POLARITY_LOW;

    /* YUV Sensor Input Format */
    ENABLE_CAMERA_INDATA_FORMAT;            /* Enable yuv data input */
    SET_CAMERA_INPUT_TYPE(INPUT_YUV422);    /* SP0827_SERIAL support YUV422 */
    SET_CAMERA_INPUT_ORDER(INPUT_ORDER_CbYCrY1);

    /* Reset the sensor */
    SP0827_SERIAL_RESET_PIN_LOW;
    kal_sleep_task(1);
    SP0827_SERIAL_RESET_PIN_HIGH;
    kal_sleep_task(1);  /* delay for stable sensor */

	
/*****SET SPI_CLK SPI_DATA GPIO MODE***/
  	GPIO_ModeSetup(SP0827_SERIAL_SPI_DATA_PIN,2);	// 2:CAM_CSD
	GPIO_ModeSetup(SP0827_SERIAL_SPI_CLOCK_PIN,2);	// 2:CAM_CSK

/*****SET I2C GPIO MODE***/	
#ifdef SP0827_SERIAL_HW_SCCB
	GPIO_ModeSetup(SP0827_SERIAL_I2C_CLOCK_PIN, 3);	
	GPIO_ModeSetup(SP0827_SERIAL_I2C_DATA_PIN, 3);
#else
	GPIO_ModeSetup(SP0827_SERIAL_I2C_CLOCK_PIN,0);
	GPIO_ModeSetup(SP0827_SERIAL_I2C_DATA_PIN,0);		
	GPIO_WriteIO(1, SP0827_SERIAL_I2C_CLOCK_PIN);		
	GPIO_WriteIO(1, SP0827_SERIAL_I2C_DATA_PIN);		      
	GPIO_InitIO(1, SP0827_SERIAL_I2C_CLOCK_PIN);		
	GPIO_InitIO(1, SP0827_SERIAL_I2C_DATA_PIN);
#endif

 	
/*******gpio CMPDN*****/
	GPIO_ModeSetup(SP0827_SERIAL_POWERDOWN_PIN, 0);
    GPIO_InitIO(1, SP0827_SERIAL_POWERDOWN_PIN);

	
    kal_sleep_task(4);
	GPIO_WriteIO(0, SP0827_SERIAL_POWERDOWN_PIN);
  	kal_sleep_task(1); 
    GPIO_WriteIO(1, SP0827_SERIAL_POWERDOWN_PIN);
	kal_sleep_task(4); 
	GPIO_WriteIO(0, SP0827_SERIAL_POWERDOWN_PIN);
	kal_sleep_task(2); 
  
    
    /* Read Sensor ID  */

   	sensor_id = SP0827_SERIAL_read_cmos_sensor(0x02);//(0x01) ; 
   //	sensor_id = SP0827_SERIAL_read_cmos_sensor(0x02);//(0x01) ;
    dbg_print("sensor_id=%x\r\n",sensor_id);
	
    return sensor_id;
}

/*****************************************************************************
 * FUNCTION
 *  SP0827_SERIAL_PowerOff
 * DESCRIPTION
 *  This function is to turn off sensor module power.
 * PARAMETERS
 *  void
 * RETURNS
 *  void
 *****************************************************************************/

static void SP0827_SERIAL_PowerOff(void)
{
	dbg_print("SP0827_SERIAL_PowerOff\r\n");
    SP0827_SERIAL_write_cmos_sensor(0x0e, 0xff);  //sensor sleep mode

    cis_module_power_on(KAL_FALSE);         // power off sensor   


/*******ΪȷSENSOR˳ʱ©磬powerdownܽ ˳ʱҪ******/

	GPIO_ModeSetup(SP0827_SERIAL_POWERDOWN_PIN, 0);
    GPIO_InitIO(1, SP0827_SERIAL_POWERDOWN_PIN);
	
    GPIO_WriteIO(0, SP0827_SERIAL_POWERDOWN_PIN);
  	kal_sleep_task(0); 
    GPIO_WriteIO(1, SP0827_SERIAL_POWERDOWN_PIN);
	kal_sleep_task(4); 
	GPIO_WriteIO(0, SP0827_SERIAL_POWERDOWN_PIN);
	kal_sleep_task(2); 
	

#ifndef SP0827_SERIAL_HW_SCCB	
    SET_SCCB_CLK_LOW;
    SET_SCCB_DATA_LOW;
#endif    
#if (defined(DRV_ISP_6238_SERIES))
    setCameraCPLLPowerDown();
#else
//#if !(defined(DRV_ISP_YUV_BURST_MODE_SUPPORT))
    UPLL_Disable(UPLL_OWNER_ISP);
//#endif
#endif
}   /* SP0827_SERIAL_PowerOff */ 


/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Init
*
* DESCRIPTION
*   This function initialize the registers of CMOS sensor and ISP control register.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_Initial_Setting(void);

static kal_int8 SP0827_SERIAL_Init(void)
{
    kal_uint16 sensor_id = 0;
    

    sensor_id = SP0827_SERIAL_PowerOn();


    if (SP0827_SENSOR_ID != sensor_id)
        return -1;  /* The sensor is not SP0827_SERIAL */

	SP0827_SERIAL_Initial_Setting();//0829ĳʼ
    
    SP0827_SERIAL_Video_Mode = KAL_FALSE;
    SP0827_SERIAL_g_bNightMode = KAL_FALSE;
    SP0827_SERIAL_g_iBanding = CAM_BANDING_50HZ;
	
     
    return 1;   

}   /* SP0827_SERIAL_Init() */

kal_uint32 SP0827_SERIAL_detect_sensor_id(void)
{
    kal_uint16 SP0827_SERIAL_sensor_id = 0;
    
    SP0827_SERIAL_sensor_id = SP0827_SERIAL_PowerOn();
    SP0827_SERIAL_PowerOff();    
	dbg_print("SP0827_SERIAL_detect_sensor_id=%x\r\n",SP0827_SERIAL_sensor_id);
    return SP0827_SERIAL_sensor_id;       

}

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Get_I2C_ID
*
* DESCRIPTION
*   This function return the sensor read/write IDs of I2C I/F.
*
* PARAMETERS
*   *pI2C_WriteID : address pointer of sensor's I2C write id
*   *pI2C_ReadID  : address pointer of sensor's I2C read id
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_Get_I2C_ID(kal_uint8 *pI2C_WriteID, kal_uint8 *pI2C_ReadID)
{
    /* No need for YUV sensor driver */
}   /* SP0827_SERIAL_Get_I2C_ID */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_GetSize
*
* DESCRIPTION
*   This function return the image width and height of image sensor.
*
* PARAMETERS
*   *pWidth : address pointer of horizontal effective pixels of image sensor
*  *pHeight : address pointer of vertical effective lines of image sensor
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_GetSize(kal_uint16 *pWidth, kal_uint16 *pHeight)
{
 
    /* No need for YUV sensor driver */
}   /* SP0827_SERIAL_GetSize */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_GetPeriod
*
* DESCRIPTION
*   This function return the image width and height of image sensor.
*
* PARAMETERS
*   *pPixelNumber : address pointer of pixel numbers in one period of HSYNC
*   *pLineNumber : address pointer of line numbers in one period of VSYNC
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_GetPeriod(kal_uint16 *pPixelNumber, kal_uint16 *pLineNumber)
{
    /* No need for YUV sensor driver */
}   /* SP0827_SERIAL_GetPeriod */




/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Preview
*
* DESCRIPTION
*   This function configure the sensor to preview mode.
*
* PARAMETERS
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
#if(defined(SP0829_SERIAL_YUV))
unsigned char Dual_Camera_SP0827_CONFIG[] =
{                                           
	 0x1c , 0x00,                              
	 0x30 , 0x16,                              
	 0x27 , 0x38,                              
	 0x28 , 0x0b,                              
	 0xE7 , 0x03,                              
	 0xE7 , 0x00,                              
	 0x32 , 0x00,                              
	 0x03 , 0x01,                              
	 0x04 , 0x90,                              
	 0x24 , 0x2a, 
	 0x0e , 0x00,
	                                           
	//analog  for 1bit                         
	  0x0f , 0x06,                             
	  0x10 , 0x06,                             
	  0x12 , 0x05,                             
	  0x13 , 0x03,                             
	  0x14 , 0x08,                             
	  0x15 , 0x02,                             
	  0x16 , 0x00,                             
	  0x17 , 0x01,                             
	  0x18 , 0x00,                             
	  0x1a , 0x0f,                             
	                                           
	//AE  24M 8Ƶ for 1bit 15-8fps           
	//ae setting                                                            
	  0x06 , 0x0 ,                             
	  0x09 , 0x0 ,                             
	  0x0a , 0x2c,                             
	//base                                     
	  0x97 , 0x32,                             
	  0x98 , 0x0 ,                             
	//exp                                      
	  0x70 , 0x58,                             
	  0x71 , 0x2 ,                             
	  0x72 , 0x32,                             
	  0x73 , 0x0 ,                             
	  0x78 , 0x32,                             
	  0x79 , 0x0 ,                             
	  0x7a , 0x1 ,                             
	  0x7b , 0x0 ,                             
	//gain                                     
	  0x74 , 0x70,                             
	  0x75 , 0x2a,                             
	  0x7c , 0x50,                             
	  0x7d , 0x2a,                             
	  0x80 , 0x50,                             
	  0x81 , 0x3e,                             
	  0x82 , 0x36,                             
	  0x83 , 0x30,                             
	  0x84 , 0x30,                             
	  0x85 , 0x2e,                             
	  0x86 , 0x2e,                             
	  0x87 , 0x2c,                             
	  0x88 , 0x2c,                             
	  0x89 , 0x2c,                             
	  0x8a , 0x2a,                             
	  0x8b , 0x2a,                             
	  0x8c , 0x2a,                             
	//target                                   
	  0x90 , 0x50, //indoor hold               
	  0x93 , 0x4c,	//idoor lock               
	  0x94 , 0x44,                             
	  0x8f , 0x40,                             
	  0x92 , 0x50,	//otdoor hold              
	  0x95 , 0x4c,	//otdoor lock              
	  0x96 , 0x44,                             
	  0x91 , 0x40,                             
	                                           
	//Status                                                                
	  0x60 , 0x40,//mean_nr_dummy              
	  0x61 , 0x50,//mean_dummy_nr              
	  0x62 , 0x20,//mean_dummy_low             
	  0x63 , 0x35,//mean_low_dummy             
	  0x64 , 0x70,//rpc_heq_low                
	  0x65 , 0x70,//rpc_heq_dummy              
	  0x66 , 0x58,//exp_heq_dummy_8lsm         
	  0x67 , 0x02,//exp_heq_dummy_5hsm         
	  0x68 , 0x58,//exp_heq_low_8lsm           
	  0x69 , 0x02,//exp_heq_low_5hsm           
	                                           
	  0x99 , 0x09,                             
	  0x32 , 0x05,                             
	                                           

};

unsigned char Dual_Camera_SP0829_CONFIG[] =
{
	0x1c , 0x00,                         
	0x2e , 0xf0,//   for sp0827          
	0x32 , 0x00,                         
	0x2c , 0x05,                         
	0x31 , 0x10, 
	0x30 , 0x06,
	0x35 , 0x40,//0x40
	0x0e , 0xf7,//disable sp0829 analog output
	                                  
	                                  
	//AWB                                  
	0xc5 , 0xc4,                         
	0xc6 , 0x9f,                         
	0xE7 , 0x03,                         
	0xE7 , 0x00,     
	0xbe , 0x20,                    
	0xb3 , 0x7e, 
	0xb5 , 0x10,
	0xd4 , 0xff,
	0xba , 0x2d,                         
	0xd7 , 0x90,                         
	0xd8 , 0xa0,                         
	0xd9 , 0xff,                         
	0xdd , 0xa6,                         
	0xe1 , 0xc7,                         
	0xe3 , 0xd0,                         
	0xd5 , 0xe0,                         
	                                  
	//smooth                               
	0x42 , 0x54,//03//02//               
	0x46 , 0x0a,                         
	                                  
	//sharpen                              
	0x50 , 0x40,                         
	0x51 , 0x10,                         
	0x52 , 0xe0, 
	0x55 , 0x10, 
	                                              
	0x56 , 0x30,			
	0x57 , 0x20,                         
	//cm                                   
	0x79 , 0xb1,
	0x7a , 0xcf,
	0x7b , 0x00,
	0x7c , 0x19,
	0x7d , 0x70,
	0x7e , 0xf7,
	0x7f , 0x18,
	0x80 , 0xc1,
	0x81 , 0xa6,
	0x82 , 0x0c,
	0x83 , 0x30,
	0x84 , 0x0c,
	
	/*/color ԭԺ
        0x79 , 0x96,
        0x7a , 0xf1,
        0x7b , 0xfa,
        0x7c , 0xe5,
        0x7d , 0xc6,
        0x7e , 0xd6,
        0x7f , 0xff,
        0x80 , 0x96,
        0x81 , 0xeb,
        0x82 , 0x3c,
        0x83 , 0x33,
        0x84 , 0x0f,*/     
                                       
        //sat          
        0x4f , 0x60, 
        0x58 , 0xff, 
        0x59 , 0xff, 
              
        //heq          
        0x5b , 0x80, 
        0x5c , 0xa0, 

	//auto lum lowlight 		   
	0x86 , 0x30,			
	0x87 , 0x1f,			
	0x88 , 0x30,			
	0x89 , 0x45,						  
	//gama
        0x65 , 0x0 ,
        0x66 , 0xa ,
        0x67 , 0x13,
        0x68 , 0x25,
        0x69 , 0x43,
        0x6a , 0x5d,
        0x6b , 0x74,
        0x6c , 0x88,
        0x6d , 0x9a,
        0x6e , 0xa9,
        0x6f , 0xb5,
        0x70 , 0xc0,
        0x71 , 0xca,
        0x72 , 0xd4,
        0x73 , 0xdd,
        0x74 , 0xe6,
        0x75 , 0xef,
        0x76 , 0xf7,
        0x77 , 0xff,
                                                 
	                                  
	0x33 , 0x0f,                         
	0x34 , 0x06,                         
	0x32 , 0x08,                         

};

static kal_uint32 Dual_Camera_SP0829_SERIAL_Set_Para_WB(kal_uint32 iPara)
{ 
	dbg_print("!!!!!!SP0827_SERIAL_Set_Para_WB iPara=%d\r\n",iPara);
    switch (iPara)
    {
        case CAM_WB_AUTO:   // enable AWB                                              
            // CAM_WB_AUTO mode should not update R/G/B gains                                       
			SP0829_SERIAL_write_cmos_sensor(0xc5, 0xc4);           
			SP0829_SERIAL_write_cmos_sensor(0xc6, 0x9f);  
			 SP0829_SERIAL_write_cmos_sensor(0xe7, 0x03);
	           
			SP0829_SERIAL_write_cmos_sensor(0x32, 0x08);           
            return KAL_TRUE;                                                   
                                                                               
        case CAM_WB_CLOUD:                                                     
            SP0829_SERIAL_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0829_SERIAL_write_cmos_sensor(0xc5, 0xe5);                       
            SP0829_SERIAL_write_cmos_sensor(0xc6, 0x80);                       
            break;                                                             
                                                                               
        case CAM_WB_DAYLIGHT:                                                  
            SP0829_SERIAL_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0829_SERIAL_write_cmos_sensor(0xc5, 0xc5);                       
            SP0829_SERIAL_write_cmos_sensor(0xc6, 0x8a);                       
            break;                                                             
                                                                               
        case CAM_WB_INCANDESCENCE:                                             
            SP0829_SERIAL_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0829_SERIAL_write_cmos_sensor(0xc5, 0x7f);                       
            SP0829_SERIAL_write_cmos_sensor(0xc6, 0x88);                       
            break;                                                             
                                                                               
        case CAM_WB_FLUORESCENT:                                               
             SP0829_SERIAL_write_cmos_sensor(0x32, 0x00);  // disable AWB      
            SP0829_SERIAL_write_cmos_sensor(0xc5, 0x9c);                       
            SP0829_SERIAL_write_cmos_sensor(0xc6, 0xaf);                       
            break;                                                             
                                                                               
        case CAM_WB_TUNGSTEN:                                                  
            SP0829_SERIAL_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0829_SERIAL_write_cmos_sensor(0xc5, 0xa8);                       
            SP0829_SERIAL_write_cmos_sensor(0xc6, 0xb7);                       
            break;                                                             


        case CAM_WB_MANUAL:
        default:
            return KAL_FALSE;
    }
    return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_WB */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Set_Para_EV
*
* DESCRIPTION
*   SP0827_SERIAL exposure setting.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 Dual_Camera_SP0829_SERIAL_Set_Para_EV(kal_uint32 iPara)
{
	switch (iPara)
    {

		case CAM_EV_NEG_4_3:    // -4 EV                                
			SP0829_SERIAL_write_cmos_sensor(0x78,0xc0);     
		                                                     
		    break;                                               
		case CAM_EV_NEG_3_3:    // -3 EV                                 
			SP0829_SERIAL_write_cmos_sensor(0x78,0xd0);     
			break;                                               
		                                         
		case CAM_EV_NEG_2_3:    // -2 EV                         
			SP0829_SERIAL_write_cmos_sensor(0x78,0xe0);     
			break;                                               
		                                                     
		case CAM_EV_NEG_1_3:    // -1 EV                         
			SP0829_SERIAL_write_cmos_sensor(0x78,0xf0);     
			break;                                               
		                                                     
		case CAM_EV_ZERO:    // +0 EV                            
			SP0829_SERIAL_write_cmos_sensor(0x78,0x00);         
			break;                                               
		                                                     
		case CAM_EV_POS_1_3:   // +1 EV                         
			SP0829_SERIAL_write_cmos_sensor(0x78,0x10);    
			break;                                               
		                                                     
		case CAM_EV_POS_2_3:    // +2 EV                         
			SP0829_SERIAL_write_cmos_sensor(0x78,0x20);    
			break;                                               
		                                                     
		case CAM_EV_POS_3_3:    // +3 EV                         
			SP0829_SERIAL_write_cmos_sensor(0x78,0x30);         
			break;                                               
		                                                     
		case CAM_EV_POS_4_3:    // +4EV                          
			SP0829_SERIAL_write_cmos_sensor(0x78,0x40);          
			break;                                               

        default:
            return KAL_FALSE;    
    }
    return KAL_TRUE;
}

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Set_Para_Effect
*
* DESCRIPTION
*   SP0827_SERIAL
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 Dual_Camera_SP0829_SERIAL_Set_Para_Effect(kal_uint32 iPara)
{
    switch (iPara)
    {
       case CAM_EFFECT_ENC_NORMAL:                                                            
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x00);                                
		   SP0829_SERIAL_write_cmos_sensor(0x63, 0x80);                    
		   SP0829_SERIAL_write_cmos_sensor(0x64, 0x80);                    
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_GRAYSCALE:                                                  
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x08);                                
		   SP0829_SERIAL_write_cmos_sensor(0x63, 0x80);                    
		   SP0829_SERIAL_write_cmos_sensor(0x64, 0x80);                    
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_SEPIA:                                                      
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x04);                                
		SP0829_SERIAL_write_cmos_sensor(0x63, 0xc0);                    
		SP0829_SERIAL_write_cmos_sensor(0x64, 0x20);                    
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_SEPIAGREEN:                                                 
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x04);                                
		   SP0829_SERIAL_write_cmos_sensor(0x63, 0x50);                    
		   SP0829_SERIAL_write_cmos_sensor(0x64, 0x50);                    
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_SEPIABLUE:                                                  
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x04);                                 
		   SP0829_SERIAL_write_cmos_sensor(0x63, 0x20);                    
		   SP0829_SERIAL_write_cmos_sensor(0x64, 0xf0);                    
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_COLORINV:                                                   
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x01);                                
		   SP0829_SERIAL_write_cmos_sensor(0x63, 0x80);                    
		   SP0829_SERIAL_write_cmos_sensor(0x64, 0x80);                    
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_GRAYINV:                                                    
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x02);                                
		   SP0829_SERIAL_write_cmos_sensor(0x63, 0x80);                    
		   SP0829_SERIAL_write_cmos_sensor(0x64, 0x80);                    
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_EMBOSSMENT:                                                 
           SP0829_SERIAL_write_cmos_sensor(0x62, 0x00);                                
		   SP0829_SERIAL_write_cmos_sensor(0x63, 0x80);                    
		   SP0829_SERIAL_write_cmos_sensor(0x64, 0x80);                    
                                                                                       
           break;                                                                      
                                                                                      
            
        default:
            return KAL_FALSE;
    }
    return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_Effect */
#elif(defined(SP0A18_YUV))
unsigned char Dual_Camera_SP0827_CONFIG[] = { 
  0x1c , 0x00,                              
  0x30 , 0x16,                              
  0x27 , 0x38,                              
  0x28 , 0x0b,                              
  0xE7 , 0x03,                              
  0xE7 , 0x00,                              
  0x32 , 0x00,                              
  0x03 , 0x01,                              
  0x04 , 0x90,                              
  0x24 , 0x2a, 
  0x0e , 0x00,
  
  0x0f , 0x06,
  0x10 , 0x06, 
  0x12 , 0x05,
  0x13 , 0x03,
  0x14 , 0x08,
  0x15 , 0x02, 
  0x16 , 0x00,
  0x17 , 0x01, 
  0x18 , 0x00,
  0x1a , 0x0f,
         
	//AE  24M 8Ƶ for 1bit 15-8fps           
////ae setting
  0x06 , 0x0 ,
  0x09 , 0x0 ,
  0x0a , 0x2c,                             
////base     
  0x97 , 0x32,
  0x98 , 0x0 ,
////exp     
  0x70 , 0x58,
  0x71 , 0x2 ,
  0x72 , 0x32,
  0x73 , 0x0 ,
  0x78 , 0x32,
  0x79 , 0x0 ,
  0x7a , 0x1 ,
  0x7b , 0x0 ,
//gain     
  0x74 , 0x70,
  0x75 , 0x2a,
  0x7c , 0x50,
  0x7d , 0x2a,
  0x80 , 0x50,
  0x81 , 0x3e,
  0x82 , 0x36,
  0x83 , 0x30,
  0x84 , 0x30,
  0x85 , 0x2e,
  0x86 , 0x2e,
  0x87 , 0x2c,
  0x88 , 0x2c,
  0x89 , 0x2c,
  0x8a , 0x2a,
  0x8b , 0x2a,
  0x8c , 0x2a,
//target     
  0x90 , 0x50,//60 //indoor hold
  0x93 , 0x4c,//5c	//indoor lock
  0x94 , 0x44,//54
  0x8f , 0x40,//50 
  0x92 , 0x50,//60	//outdoor hold
  0x95 , 0x4c,//5c	//outdoor lock
  0x96 , 0x44,//54
  0x91 , 0x40,//50      
            
//status     
        
  0x60 , 0x40,//mean_nr_dummy
  0x61 , 0x50,//mean_dummy_nr
  0x62 , 0x20,//mean_dummy_low
  0x63 , 0x35,//mean_low_dummy
  0x64 , 0x70,//rpc_heq_low
  0x65 , 0x70,//rpc_heq_dummy
  0x66 , 0x58,//exp_heq_dummy_8lsm
  0x67 , 0x02,//exp_heq_dummy_5hsm
  0x68 , 0x58,//exp_heq_low_8lsm
  0x69 , 0x02,//exp_heq_low_5hsm
  
  0x99 , 0x09,         
  0x32 , 0x05,

};

unsigned char Dual_Camera_SP0A18_CONFIG[] = { 
  0xfd , 0x00,
  0x0e , 0xf7, //disable sp0a18 analog output
  0x2e , 0xf0,
  0x2c , 0x0e,
  0x1b , 0x05,
  0x1c , 0x00,//
  
  //240*320 for sp0827
  0xfd , 0x00,
  0x47 , 0x00,
  0x48 , 0x00,
  0x49 , 0x01,
  0x4a , 0x40,
  0x4b , 0x00,
  0x4c , 0x00,
  0x4d , 0x00,
  0x4e , 0xf0,
            
  0x30 , 0x00,
  
  0x32 , 0x00, 
  0xfd , 0x01,
  0x28 , 0xc4,
  0x29 , 0x9e,
  0xfd , 0x00,
  0xe7 , 0x03,
  0xe7 , 0x00,
        
//special   
  0xfd , 0x01,
  0x00 , 0x01,
//pregain   
  0xc6 , 0x0a,//a~f
  0xc7 , 0x0a,//a~f
  0xc8 , 0x0a,//a~f
  0xc9 , 0x0a,//a~f
  
//AWB     
  0xfd , 0x01,
        
  0x10 , 0x0d,//
  0x11 , 0x08,//d
  0x12 , 0x08,//d
  0x17 , 0x27,//2f 
  0x18 , 0x45, 
  0x1a , 0xb2,//AC?//9e
  0x1b , 0xbb,//9e,
  0x2a , 0xE0,
  0x2b , 0x10,//35
  0x2c , 0x9f,//90
  0x2d , 0x99,
  0x2e , 0x99,
  0x6f , 0x0a,//05
  0x8b , 0x2f,
       
  0x20 , 0xd0,
  0x21 , 0x78,
  0x22 , 0xe0,
  0x23 , 0x80,
  0x16 , 0x08,//14
//smooth   
  0xfd , 0x00,
  0x4f , 0x54,//43 raw_gf_fac_outdoor raw_gf_fac_nr 55
  0x50 , 0x22,//11 draw_gf_fac_dummy raw_gf_fac_low
  0x57 , 0x06,//06 raw_dif_thr_outdoor
  0x58 , 0x0f,//16 raw_dif_thr_normal
  0x56 , 0x10,//18 dummy
  0x59 , 0x10,//18 low
          
  0x5a , 0x70,// raw_rb_fac_outdoor,raw_rb_fac_nr
  0x5b , 0x00,// raw_rb_fac_dummy,raw_rb_fac_low
       
//sharpen
  0xfd , 0x01,
  0xe5 , 0x20,
  0xe6 , 0x10,
  0xe7 , 0x20,    
  0xe8 , 0x38,//sharp_fac_pos_outdoor
  0xec , 0x38,//sharp_fac_neg_outdoor
  0xe9 , 0x30,//sharp_fac_pos_nr
  0xed , 0x30,//sharp_fac_neg_nr
  0xea , 0x30,//sharp_fac_pos_dummy
  0xef , 0x30,//sharp_fac_neg_dummy
  0xeb , 0x10,//sharp_fac_pos_low
  0xf0 , 0x20,//sharp_fac_neg_low
        
//gamma     
 0xfd , 0x00,
 0x8b , 0x0 , //,0 
 0x8c , 0xC ,//,11
 0x8d , 0x19,//,19 
 0x8e , 0x2C,//,28 
 0x8f , 0x49,//,46 
 0x90 , 0x61,//,61 
 0x91 , 0x77,//,78 
 0x92 , 0x8A,//,8A 
 0x93 , 0x9B,//,9B 
 0x94 , 0xA9,//,A9 
 0x95 , 0xB5,//,B5 
 0x96 , 0xC0,//,C0 
 0x97 , 0xCA,//,CA 
 0x98 , 0xD4,//,D4 
 0x99 , 0xDD,//,DD 
 0x9a , 0xE6,//,E6 
 0x9b , 0xEF,//,EF 
 0xfd , 0x01,//,01 
 0x8d , 0xF7,//,F7 
 0x8e , 0xFF,//,FF 
             
//uv en     
  0xfd , 0x00,
  0xb0 , 0x00,//uv_dif_gain_outdoor,uv_dif_gain_nr
  0xb1 , 0x33,//uv_dif_gain_dummy,uv_dif_gain_low   
        
//neg       
  0xfd , 0x01,
  0xd2 , 0x00, 
      
//lowlight lu
  0xfd , 0x00,
  0xb2 , 0x08,//lum_limit
  0xb3 , 0x1f,//lum_set
  0xb4 , 0x20,//black_vt
  0xb5 , 0x45,//white_vt
      
//auto sat   
  0xfd , 0x00,
  0xbf , 0x01,//autosa_en
  0xc0 , 0xff,//a0//y_p_th
  0xc1 , 0xff,//a0//y_mean_th
           
//saturation 
  0xfd , 0x00,
  0xd8 , 0x80,//74//88sat_uv_s1
  0xd9 , 0x80,//74//88sat_uv_s2
  0xda , 0x80,//74//88sat_uv_s3
  0xdb , 0x80,//74//88sat_uv_s4
        
//heq        
  0xfd , 0x00,
  0xdc , 0x00,//heq_offset
  0xdd , 0x80,///ku
  0xde , 0xa8,//b0//kl
  0xdf , 0x70,//heq_mean
          
//CCM        
  0xfd , 0x01,
  0xa0 , 0x80,//80(ɫӽɫ)
  0xa1 , 0x0 ,//0 
  0xa2 , 0x0 ,//0 
  0xa3 , 0xf3,//f0
  0xa4 , 0x8e,//a6
  0xa5 , 0x0 ,//ea
  0xa6 , 0x0 ,//0 
  0xa7 , 0xe6,//e6
  0xa8 , 0x9a,//9a
  0xa9 , 0x0 ,//0 
  0xaa , 0x3 ,//33
  0xab , 0xc ,//c 
     
//skin      
  0xfd , 0x01,
           
  0x8b , 0x2f,//bit7,0 en
  0x01 , 0xf0,
  0x02 , 0x04,
  0x03 , 0x70,
  0x04 , 0x99,//88
  0x05 , 0x24,//13
//resize_en  
  0xfd , 0x01,
  0x0e , 0x00,
         
//outformat  
  0xfd , 0x00,
  0x35 , 0x80,
  0x5f , 0x01,
         
//En AWB     
  0xfd , 0x00,
  0x31 , 0x10,
  0x32 , 0x08,
  0x33 , 0x0f,  
  0x34 , 0x06, 

};

static kal_uint32 Dual_Camera_SP0A18_Set_Para_WB(kal_uint32 iPara)
{ 
	dbg_print("!!!!!!SP0827_SERIAL_Set_Para_WB iPara=%d\r\n",iPara);
    switch (iPara)
    {
        case CAM_WB_AUTO:   // enable AWB                                              
            // CAM_WB_AUTO mode should not update R/G/B gains  
         SP0A18_write_cmos_sensor(0xfd, 0x01);                                      
		 SP0A18_write_cmos_sensor(0x28, 0xc4);           
		 SP0A18_write_cmos_sensor(0x29, 0x9e);  		 
	         SP0A18_write_cmos_sensor(0xfd, 0x00); 
		 SP0A18_write_cmos_sensor(0x32, 0x08);           
            return KAL_TRUE;                                                   
                                                                               
        case CAM_WB_CLOUD:  
            SP0A18_write_cmos_sensor(0xfd, 0x00);                                                   
            SP0A18_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0A18_write_cmos_sensor(0xfd, 0x01);                     
            SP0A18_write_cmos_sensor(0x28, 0xe2); 
            SP0A18_write_cmos_sensor(0x29, 0x82); 
            SP0A18_write_cmos_sensor(0xfd, 0x00); 
                                  
            break;                                                             
                                                                               
        case CAM_WB_DAYLIGHT:                                                  
            SP0A18_write_cmos_sensor(0xfd, 0x00);                                                   
            SP0A18_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0A18_write_cmos_sensor(0xfd, 0x01);                     
            SP0A18_write_cmos_sensor(0x28, 0xc1); 
            SP0A18_write_cmos_sensor(0x29, 0x88); 
            SP0A18_write_cmos_sensor(0xfd, 0x00);                       
            break;                                                             
                                                                               
        case CAM_WB_INCANDESCENCE:                                             
            SP0A18_write_cmos_sensor(0xfd, 0x00);                                                   
            SP0A18_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0A18_write_cmos_sensor(0xfd, 0x01);                     
            SP0A18_write_cmos_sensor(0x28, 0x7b); 
            SP0A18_write_cmos_sensor(0x29, 0xd3); 
            SP0A18_write_cmos_sensor(0xfd, 0x00);                       
            break;                                                             
                                                                               
        case CAM_WB_FLUORESCENT:                                               
            SP0A18_write_cmos_sensor(0xfd, 0x00);                                                   
            SP0A18_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0A18_write_cmos_sensor(0xfd, 0x01);                     
            SP0A18_write_cmos_sensor(0x28, 0xb4); 
            SP0A18_write_cmos_sensor(0x29, 0xc4); 
            SP0A18_write_cmos_sensor(0xfd, 0x00);                       
            break;                                                             
                                                                               
        case CAM_WB_TUNGSTEN:                                                  
            SP0A18_write_cmos_sensor(0xfd, 0x00);                                                   
            SP0A18_write_cmos_sensor(0x32, 0x00);  // disable AWB       
            SP0A18_write_cmos_sensor(0xfd, 0x01);                     
            SP0A18_write_cmos_sensor(0x28, 0xae); 
            SP0A18_write_cmos_sensor(0x29, 0xcc); 
            SP0A18_write_cmos_sensor(0xfd, 0x00);                       
            break;                                                             

        case CAM_WB_MANUAL:
        default:
            return KAL_FALSE;
    }
    return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_WB */

static kal_uint32 Dual_Camera_SP0A18_Set_Para_EV(kal_uint32 iPara)
{
	switch (iPara)
    {
		case CAM_EV_NEG_4_3:    // -4 EV                                
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xc0);     
		                                                     
		    break;                                               
		case CAM_EV_NEG_3_3:    // -3 EV                                 
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xd0);    
			break;                                               
		                                         
		case CAM_EV_NEG_2_3:    // -2 EV                         
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xe0);     
			break;                                               
		                                                     
		case CAM_EV_NEG_1_3:    // -1 EV                         
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0xf0);     
			break;                                               
		                                                     
		case CAM_EV_ZERO:    // +0 EV                            
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x00);         
			break;                                               
		                                                     
		case CAM_EV_POS_1_3:   // +1 EV                         
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x10);    
			break;                                               
		                                                     
		case CAM_EV_POS_2_3:    // +2 EV                         
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x20);    
			break;                                               
		                                                     
		case CAM_EV_POS_3_3:    // +3 EV                         
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x30);         
			break;                                               
		                                                     
		case CAM_EV_POS_4_3:    // +4EV                          
			SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0xdc, 0x40);        
			break;                                               

        default:
            return KAL_FALSE;    
    }
    return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_EV */

static kal_uint32 Dual_Camera_SP0A18_Set_Para_Effect(kal_uint32 iPara)
{
    switch (iPara)
    {
       case CAM_EFFECT_ENC_NORMAL:                                                            
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x00);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);                    
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_GRAYSCALE:                                                  
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x20);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);                   
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_SEPIA:                                                      
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x10);
			SP0A18_write_cmos_sensor(0x63, 0xc0);
			SP0A18_write_cmos_sensor(0x64, 0x20);                   
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_SEPIAGREEN:                                                 
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x10);
			SP0A18_write_cmos_sensor(0x63, 0x20);
			SP0A18_write_cmos_sensor(0x64, 0x20);                   
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_SEPIABLUE:                                                  
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x10);
			SP0A18_write_cmos_sensor(0x63, 0x20);
			SP0A18_write_cmos_sensor(0x64, 0xf0);                    
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_COLORINV:                                                   
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x04);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);                   
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_GRAYINV:                                                    
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x08);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);                    
                                                                                       
           break;                                                                      
                                                                                       
       case CAM_EFFECT_ENC_EMBOSSMENT:                                                 
            SP0A18_write_cmos_sensor(0xfd, 0x00);
			SP0A18_write_cmos_sensor(0x62, 0x01);
			SP0A18_write_cmos_sensor(0x63, 0x80);
			SP0A18_write_cmos_sensor(0x64, 0x80);                   
                                                                                       
           break;                                                                      
            
        default:
            return KAL_FALSE;
    }
    return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_Effect */

#endif

void SP0827_SERIAL_Disable(void)
{       
	SP0827_SERIAL_write_cmos_sensor(0x0e,0xff);
	SP0827_SERIAL_write_cmos_sensor(0x1c,0x03);	
	SP0827_SERIAL_write_cmos_sensor(0xe7,0x03);
	SP0827_SERIAL_write_cmos_sensor(0xe7,0x00);	
}
/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Initial_Setting
*
* DESCRIPTION
*   This function initialize the registers of CMOS sensor.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_Initial_Setting(void)
{
	int i,reg_count;
	
	reg_count = sizeof(Dual_Camera_SP0827_CONFIG) / 2;
	dbg_print("reg_count=%d\r\n",reg_count);
	
	dbg_print("SP0827:\r\n");
	for (i = 0;i < reg_count;i++)
	{
		SP0827_SERIAL_write_cmos_sensor(Dual_Camera_SP0827_CONFIG[i*2],Dual_Camera_SP0827_CONFIG[i*2+1] );
		dbg_print("%x value=%x\r\n",Dual_Camera_SP0827_CONFIG[i*2],SP0827_SERIAL_read_cmos_sensor(Dual_Camera_SP0827_CONFIG[i*2]));
	}

	#if(defined(SP0829_SERIAL_YUV))
	dbg_print("SP0829:\r\n");

	reg_count = sizeof(Dual_Camera_SP0827_CONFIG) / 2;
	for (i = 0;i < reg_count;i++)
	{
		
		SP0829_SERIAL_write_cmos_sensor(Dual_Camera_SP0829_CONFIG[i*2],Dual_Camera_SP0829_CONFIG[i*2+1] );
		dbg_print("%x value=%x\r\n",Dual_Camera_SP0829_CONFIG[i*2],SP0829_SERIAL_read_cmos_sensor(Dual_Camera_SP0829_CONFIG[i*2]));
	}

	#elif(defined(SP0A18_YUV))
	
	dbg_print("SP0A18:\r\n");
	reg_count = sizeof(Dual_Camera_SP0A18_CONFIG) / 2;
	for (i = 0;i < reg_count;i++)
	{
		
		SP0A18_write_cmos_sensor(Dual_Camera_SP0A18_CONFIG[i*2],Dual_Camera_SP0A18_CONFIG[i*2+1] );
		dbg_print("%x value=%x\r\n",Dual_Camera_SP0A18_CONFIG[i*2],SP0A18_read_cmos_sensor(Dual_Camera_SP0A18_CONFIG[i*2]));
	}

	#endif
	
}

static void SP0827_SERIAL_Preview(image_sensor_exposure_window_struct *pImage_Window, image_sensor_config_struct *pSensor_Config_Data)
{
	int i;
    kal_uint8 iStartX = 0, iStartY = 1;
    kal_bool  SP0827_SERIAL_Mode_temp = KAL_FALSE;
	
	dbg_print("pSensor_Config_Data->isp_op_mode=%d\r\n",pSensor_Config_Data->isp_op_mode);
	
#if (defined(__DYNAMIC_SENSOR_DELAY__ ))    
    pImage_Window->wait_stable_frame = 3 ;
#endif
    pImage_Window->grab_start_x = iStartX;
    pImage_Window->grab_start_y = iStartY;
    pImage_Window->exposure_window_width = (SP0827_SERIAL_IMAGE_SENSOR_QVGA_WIDTH-2) - 2 * iStartX;//(SP0827_SERIAL_IMAGE_SENSOR_CIF_WIDTH) - 2 * iStartX;//(SP0827_SERIAL_IMAGE_SENSOR_CIF_WIDTH-2) - 2 * iStartX;
    pImage_Window->exposure_window_height =SP0827_SERIAL_IMAGE_SENSOR_QVGA_HEIGHT - 2 * iStartY;

    /* serial sensor v2 */
    SP0827_sensor_para_set.sensor_pclk_inv = KAL_TRUE;
    SP0827_sensor_para_set.sensor_valid_width	= SP0827_SERIAL_IMAGE_SENSOR_QVGA_WIDTH;
    SP0827_sensor_para_set.sensor_valid_height	= SP0827_SERIAL_IMAGE_SENSOR_QVGA_HEIGHT;
    SP0827_SERIAL_set_interface_info(  (kal_uint8 *)(&SP0827_sensor_para_set) );  

//	SP0827_SERIAL_Initial_Setting();//0829ĳʼ
	
//	for(i = 0;i < 10;i++)
	//	dbg_print("%x reg value = %x\r\n",SP0827_CONFIG[i*2],SP0827_SERIAL_read_cmos_sensor(SP0827_CONFIG[i*2]));

}   /* SP0827_SERIAL_Preview */ 

/*************************************************************************
* FUNCTION
*   SID201A_Capture
*
* DESCRIPTION
*   This function configures the sensor to capture mode.
*
* PARAMETERS
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_Capture(image_sensor_exposure_window_struct *pImage_Window, image_sensor_config_struct *pSensor_Config_Data)
{
    kal_uint8 iStartX = 0, iStartY = 1;

    if (pSensor_Config_Data->frame_rate == 0xF0) 
    {     
#if (defined(__DYNAMIC_SENSOR_DELAY__ ))
        pImage_Window->wait_stable_frame = 3 ;
#endif
       // pImage_Window->wait_ae_frame = 0;    
    }
    else
    {
    #if (defined(__DYNAMIC_SENSOR_DELAY__ ))
        pImage_Window->wait_stable_frame = 0;
	#endif
    }
   
    pImage_Window->grab_start_x = iStartX;
    pImage_Window->grab_start_y = iStartY;
    pImage_Window->exposure_window_width = (SP0827_SERIAL_IMAGE_SENSOR_QVGA_WIDTH-2) - 2 * iStartX;//(SP0827_SERIAL_IMAGE_SENSOR_CIF_WIDTH) - 2 * iStartX;//(SP0827_SERIAL_IMAGE_SENSOR_CIF_WIDTH-2) - 2 * iStartX;
    pImage_Window->exposure_window_height = SP0827_SERIAL_IMAGE_SENSOR_QVGA_HEIGHT - 2 *  iStartY;
}   /* SP0827_SERIAL_Capture() */
/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_WriteReg
*
* DESCRIPTION
*   This function set the register of SP0827_SERIAL.
*
* PARAMETERS
*   iAddr : the register index of SP0827_SERIAL
*   iPara : setting parameter of the specified register of SP0827_SERIAL
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_WriteReg(kal_uint32 iAddr, kal_uint32 iPara)
{
    SP0827_SERIAL_write_cmos_sensor(iAddr, iPara);
}/* SP0827_SERIAL_WriteReg() */

/*************************************************************************
* FUNCTION
*   read_cmos_sensor
*
* DESCRIPTION
*   This function read parameter of specified register from SP0827_SERIAL.
*
* PARAMETERS
*   iAddr: the register index of SP0827_SERIAL
*
* RETURNS
*   the data that read from SP0827_SERIAL
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 SP0827_SERIAL_ReadReg(kal_uint32 iAddr)
{
    return SP0827_SERIAL_read_cmos_sensor(iAddr);
}   /* SP0827_SERIAL_ReadReg() */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_SetShutter
*
* DESCRIPTION
*   This function set e-shutter of SP0827_SERIAL to change exposure time.
*
* PARAMETERS
*   shutter : exposured lines
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_SetShutter(kal_uint16 shutter)
{
    /* No use for YUV sensor */
}   /* SP0827_SERIAL_SetShutter */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_SetGain
*
* DESCRIPTION
*   This function is to set global gain to sensor.
*
* PARAMETERS
*   iGain : sensor global gain(base: 0x40)
*
* RETURNS
*   the actually gain set to sensor.
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint16 SP0827_SERIAL_SetGain(kal_uint16 iGain)
{
    /* No use for YUV sensor */
    return iGain;
}   /* SP0827_SERIAL_SetGain */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_NightMode
*
* DESCRIPTION
*   This function switch on/off night mode of SP0827_SERIAL.
*
*************************************************************************/
static void SP0827_SERIAL_NightMode(kal_bool bEnable)
{
	dbg_print("bEnable=%d\r\n",bEnable);

if (!bEnable) //daylight
	{	
	dbg_print("SP0827_SERIAL_Video_Mode=%d\r\n",SP0827_SERIAL_Video_Mode);
	if(SP0827_SERIAL_Video_Mode)	
		{
			dbg_print(" SP0827_banding=%x\r\n",SP0827_SERIAL_g_iBanding);
			if(SP0827_SERIAL_g_iBanding == CAM_BANDING_50HZ)
			{
			//Video record daylight 24M 50hz fix 14FPS 

			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0x2c);  			 
	         				   
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x32);//base			 
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);			 
	                        		  	   
	        SP0827_SERIAL_write_cmos_sensor(0x70,0x5e);//exp			 
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x32);			 
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x32);			 
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);
			
		  SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_DAYLIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_DAYLIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_DAYLIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_DAYLIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0x5e);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x01);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0x5e);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x01);
		
			dbg_print(" video 50Hz normal\r\n");
			}
			else if(SP0827_SERIAL_g_iBanding == CAM_BANDING_60HZ)
			{
			//Video record daylight 24M 60hz fix 14FPS

			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);				
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);				
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0x40);  				
	         			  	        		
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x27);//base			
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);				
	                        	  	  			
	        SP0827_SERIAL_write_cmos_sensor(0x70,0x38);//exp			
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x01);				
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x27);				
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);				
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x27);				
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);				
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);				
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);    
			            
		  SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_DAYLIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_DAYLIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_DAYLIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_DAYLIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0x38);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x01);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0x38);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x01);	
			
			dbg_print(" video 60Hz normal\r\n");
			}
		}
	else
		{
		dbg_print(" SP0828_banding=%x\r\n",SP0827_SERIAL_g_iBanding);
			if(SP0827_SERIAL_g_iBanding == CAM_BANDING_50HZ)
			{
			//caprure preview daylight 24M 50hz 15-8FPS
			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0x2c);  			 
	         				   
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x32);//base			 
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);			 
	                        		  	   
	        SP0827_SERIAL_write_cmos_sensor(0x70,0x58);//exp			 
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x02);			 
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x32);			 
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x32);			 
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);

		 SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_DAYLIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_DAYLIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_DAYLIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_DAYLIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0x58);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x02);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0x58);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x02);	
		
			dbg_print(" priview 50Hz normal\r\n");
			 
			}
			else if(SP0827_SERIAL_g_iBanding == CAM_BANDING_60HZ)
			{
			//caprure preview daylight 24M 60hz 15-8FPS

			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0x40);  			 
	         				   
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x27);//base			 
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);			 
	                        		  	   
	        SP0827_SERIAL_write_cmos_sensor(0x70,0x49);//exp			 
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x02);			 
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x27);			 
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x27);			 
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);

		SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_DAYLIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_DAYLIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_DAYLIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_DAYLIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0x49);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x02);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0x49);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x02);	
		
			dbg_print(" priview 60Hz normal\r\n");
			
			 
			}
		}	
	}
else //night mode
{
		dbg_print("SP0827_SERIAL_Video_Mode=%d\r\n",SP0827_SERIAL_Video_Mode);
        if(SP0827_SERIAL_Video_Mode)		
		{
		    dbg_print(" SP0828_banding=%x\r\n",SP0827_SERIAL_g_iBanding);
			if(SP0827_SERIAL_g_iBanding == CAM_BANDING_50HZ)
			{
			//Video record night 24M 50hz  fix 9FPS 
			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0xe4);  			 
	         				   
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x1f);//base			 
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);			 
	                        		  	   
	        SP0827_SERIAL_write_cmos_sensor(0x70,0x55);//exp			 
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x1f);			 
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x1f);			 
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);

		SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_NIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_NIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_NIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_NIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0x55);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x01);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0x55);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x01);	
			
			dbg_print(" video 50Hz night\r\n");				
			}
			else if(SP0827_SERIAL_g_iBanding == CAM_BANDING_60HZ)
			{
			//Video record night 24M 60hz fix 9FPS
			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0xe1);  			 
	         				   
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x1a);//base			 
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);			 
	                        		  	   
	        SP0827_SERIAL_write_cmos_sensor(0x70,0x52);//exp			 
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x1a);			 
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x1a);			 
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);

		 SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_NIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_NIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_NIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_NIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0x52);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x01);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0x52);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x01);	
			dbg_print(" video 60Hz night\r\n");	
			}
		}
       else
		{
		    dbg_print(" SP0828_banding=%x\r\n",SP0827_SERIAL_g_iBanding);
			if(SP0827_SERIAL_g_iBanding == CAM_BANDING_50HZ)
			{
			//caprure preview night 24M 50hz 15-5FPS 

			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0x2c);  			 
	         				   
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x32);//base			 
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);			 
	                        		  	   
	        SP0827_SERIAL_write_cmos_sensor(0x70,0xe8);//exp			 
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x03);			 
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x32);			 
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x32);			 
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);
                
		SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_NIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_NIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_NIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_NIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0xe8);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x03);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0xe8);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x03);	
		
			dbg_print(" priview 50Hz night\r\n");	
			}
			else if(SP0827_SERIAL_g_iBanding == CAM_BANDING_60HZ)
			{
			//caprure preview night 24M 60hz 15-5FPS
			SP0827_SERIAL_write_cmos_sensor(0x06,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x09,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x0a,0x40);  			 
	         				   
	        SP0827_SERIAL_write_cmos_sensor(0x97,0x27);//base			 
	        SP0827_SERIAL_write_cmos_sensor(0x98,0x00);			 
	                        		  	   
	        SP0827_SERIAL_write_cmos_sensor(0x70,0xa8);//exp			 
	        SP0827_SERIAL_write_cmos_sensor(0x71,0x03);			 
	        SP0827_SERIAL_write_cmos_sensor(0x72,0x27);			 
	        SP0827_SERIAL_write_cmos_sensor(0x73,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x78,0x27);			 
	        SP0827_SERIAL_write_cmos_sensor(0x79,0x00);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7a,0x01);			 
	        SP0827_SERIAL_write_cmos_sensor(0x7b,0x00);

		 SP0827_SERIAL_write_cmos_sensor(0x74,SP0827_NIGHT_MAXGAIN);	
	         SP0827_SERIAL_write_cmos_sensor(0x7c,SP0827_NIGHT_MAXGAIN);
			 
		  SP0827_SERIAL_write_cmos_sensor(0x64,SP0827_NIGHT_MAXGAIN);
               SP0827_SERIAL_write_cmos_sensor(0x65,SP0827_NIGHT_MAXGAIN);
			   
		  SP0827_SERIAL_write_cmos_sensor(0x66,0xa8);
		  SP0827_SERIAL_write_cmos_sensor(0x67,0x03);
		  SP0827_SERIAL_write_cmos_sensor(0x68,0xa8);
		  SP0827_SERIAL_write_cmos_sensor(0x69,0x03);	
			dbg_print(" priview 60Hz night\r\n");	
			}
		}
}



}   /* SP0827_SERIAL_NightMode */


/*************************************************************************
* FUNCTION
 *  SP0827_SERIAL_SetFlash
*
* DESCRIPTION
*   turn on/off SP0827_SERIAL flashlight .
*
* PARAMETERS
*   bEnable:
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static void SP0827_SERIAL_SetFlash(kal_bool bEnable)
{
    /*SP0827_SERIAL can't support the function */
}   /* SP0827_SERIAL_SetFlash */




/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Set_Para_Banding
*
* DESCRIPTION
*   SP0827_SERIAL banding setting.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 SP0827_SERIAL_Set_Para_Banding(kal_uint32 iPara)
{
	switch (iPara)
	{
		case CAM_BANDING_50HZ:
			SP0827_SERIAL_g_iBanding = CAM_BANDING_50HZ;
		dbg_print(" Banding 50Hz\r\n");	
		break;

		case CAM_BANDING_60HZ:
			SP0827_SERIAL_g_iBanding = CAM_BANDING_60HZ;
		dbg_print(" Banding 60Hz\r\n");	
		break;

		default:
		return KAL_FALSE;
	}

	return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_Banding */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Set_Para_NightMode
*
* DESCRIPTION
*   SP0827_SERIAL night mode setting.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 SP0827_SERIAL_Set_Para_NightMode(kal_uint32 iPara)
{
    SP0827_SERIAL_NightMode((kal_bool) iPara);
    return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_NightMode */



/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Set_Para_WB
*
* DESCRIPTION
*   SP0827_SERIAL WB setting.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 SP0827_SERIAL_Set_Para_WB(kal_uint32 iPara)
{ 
	#if(defined(SP0829_SERIAL_YUV))
	Dual_Camera_SP0829_SERIAL_Set_Para_WB(iPara);
	#elif(defined(SP0A18_YUV))
	Dual_Camera_SP0A18_Set_Para_WB(iPara);
	#endif

	return KAL_TRUE;
	
}   /* SP0827_SERIAL_Set_Para_WB */

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Set_Para_EV
*
* DESCRIPTION
*   SP0827_SERIAL exposure setting.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 SP0827_SERIAL_Set_Para_EV(kal_uint32 iPara)
{
	#if(defined(SP0829_SERIAL_YUV))
	Dual_Camera_SP0829_SERIAL_Set_Para_EV(iPara);
	#elif(defined(SP0A18_YUV))
	Dual_Camera_SP0A18_Set_Para_EV(iPara);
	#endif

	return KAL_TRUE;
}

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_Set_Para_Effect
*
* DESCRIPTION
*   SP0827_SERIAL
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 SP0827_SERIAL_Set_Para_Effect(kal_uint32 iPara)
{
	#if(defined(SP0829_SERIAL_YUV))
    Dual_Camera_SP0829_SERIAL_Set_Para_Effect(iPara);
	#elif(defined(SP0A18_YUV))
	Dual_Camera_SP0A18_Set_Para_Effect(iPara);
	#endif

	return KAL_TRUE;
}   /* SP0827_SERIAL_Set_Para_Effect */


#if (defined(SENSOR_COMMON_INTERFACE_SUPPORT))

MM_ERROR_CODE_ENUM SP0827_SERIAL_get_sensor_common_info(PSENSOR_COMMON_INFO_STRUCT out)
{
	out->sensor_if_type = SENSOR_IF_SERIAL;
	out->preview_data_format = SENSOR_DATA_FORMAT_YUV422_VYUY;
	out->capture_data_format = SENSOR_DATA_FORMAT_YUV422_VYUY;
	out->video_data_format = SENSOR_DATA_FORMAT_YUV422_VYUY;
	out->sensor_preview_height = 176;
	out->sensor_preview_width = 220;//288;
	out->sensor_full_height = 320;//352;
	out->sensor_full_width = 240;//288;
	out->sensor_video_height = 320;//352;
	out->sensor_video_width = 240;//288;
	return ERROR_NONE;	
}
/*************************************************************************
* FUNCTION
*    SP0827_SERIAL_feature_control
*
* DESCRIPTION
*    This function provide lots of features for upper layer
*
* PARAMETERS
*    feature_id
*    p_feature_para_input: input msg
*    p_feature_para_output: output msg
*    feature_para_output_length: output length
*
* RETURNS
*    error code
*
* LOCAL AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0827_SERIAL_feature_control(IMAGE_SENSOR_FEATURE_ENUM feature_id, void *in, void *out, kal_uint16 out_len)
{
  switch (feature_id)
  {
  case SENSOR_FEATURE_VIDEO_FRAME_RATE:
    	
    break;
 case SENSOR_FEATURE_GET_COMMON_INFO:
    	//return SP0827_SERIAL_get_sensor_common_info(((PSENSOR_FEATURE_CONTRL_STRUCT)out)->pSensorCommonInfoPara);
	SP0827_SERIAL_get_sensor_common_info(((PSENSOR_FEATURE_CONTRL_STRUCT)out)->pSensorCommonInfoPara);
    break;
 case SENSOR_FEATURE_GET_INTERFACE_INFO:
     SP0827_SERIAL_get_interface_info((kal_uint8 *)((PSENSOR_FEATURE_CONTRL_STRUCT)out)->pSensorIfInforPara);
	return;
    break;

  default:
    	return ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    break;    
  }
}

#endif

/*************************************************************************
* FUNCTION
*   SP0827_SERIAL_YUV_SensorSetting
*
* DESCRIPTION
*   This function sends command and parameter to YUV-mode SP0827_SERIAL to configure it
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static kal_uint32 SP0827_SERIAL_YUV_SensorSetting(kal_uint32 iCmd, kal_uint32 iPara)
{
    kal_uint32 iRet = KAL_FALSE;    
    
    switch (iCmd)
    {
        case CAM_PARAM_WB:
            iRet = SP0827_SERIAL_Set_Para_WB(iPara);
            break;

        case CAM_PARAM_EXPOSURE:
        case CAM_PARAM_EV_VALUE:
            iRet = SP0827_SERIAL_Set_Para_EV(iPara);
            break;

        case CAM_PARAM_EFFECT:
            iRet = SP0827_SERIAL_Set_Para_Effect(iPara);
            break;

        case CAM_PARAM_BANDING:
            iRet = SP0827_SERIAL_Set_Para_Banding(iPara);
            break;

        case CAM_PARAM_NIGHT_MODE:
            iRet = SP0827_SERIAL_Set_Para_NightMode(iPara);
            break;
            
        case CAM_PARAM_AE_METERING:
            break;
#ifdef __PANORAMA_VIEW_SUPPORT__
		case CAM_PARAM_3A_ENABLE:
		
			break;
#endif
        default:
            return KAL_FALSE;
    }
    return iRet;
}   /* SP0827_SERIAL_YUV_SensorSetting */

/*************************************************************************
* FUNCTION
*   image_sensor_func_OV76X0
*
* DESCRIPTION
*   OV76X0 Image Sensor functions struct.
*
* PARAMETERS
*   none
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
static image_sensor_func_struct image_sensor_func_SP0827_SERIAL = 
{
    SP0827_SERIAL_Init,
    SP0827_SERIAL_Get_I2C_ID,
    SP0827_SERIAL_GetSize,
    SP0827_SERIAL_GetPeriod,
    SP0827_SERIAL_Preview,
    SP0827_SERIAL_Capture,
    SP0827_SERIAL_WriteReg,
    SP0827_SERIAL_ReadReg,
    SP0827_SERIAL_SetShutter,
    SP0827_SERIAL_NightMode,
    SP0827_SERIAL_PowerOff,
    SP0827_SERIAL_SetGain,
    SP0827_SERIAL_SetFlash,
#if (defined(DRV_ISP_6238_SERIES))
    NULL,
    NULL,
#if (defined(MSHUTTER_SUPPORT))
    NULL,
    NULL,
#endif
#endif
#if (defined(SENSOR_COMMON_INTERFACE_SUPPORT))
	SP0827_SERIAL_feature_control,
#endif
    SP0827_SERIAL_YUV_SensorSetting
};  /* image_sensor_func_SP0827_SERIAL */

/*************************************************************************
* FUNCTION
*   image_sensor_func_config
*
* DESCRIPTION
*   This function maps the external camera module function API structure.
*
* PARAMETERS
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0827_SERIAL_image_sensor_func_config(void)
{
    image_sensor_func = &image_sensor_func_SP0827_SERIAL;
}   /* image_sensor_func_config() */


/*****************************************************************************
 * FUNCTION
 *  camera_para_to_sensor
 * DESCRIPTION
 *  This function write initial setting sequence into sensor's registers
 * PARAMETERS
 *  void
 * RETURNS
 *  void
 *****************************************************************************/
void SP0827_SERIAL_camera_para_to_sensor(void)
{
    /* No use for YUV sensor */
}   /* camera_para_to_sensor */


/*****************************************************************************
 * FUNCTION
 *  sensor_to_camera_para
 * DESCRIPTION
 *  This function read back sensor's register values to camera_para structure
 * PARAMETERS
 *  void
 * RETURNS
 *  void
 *****************************************************************************/
void SP0827_SERIAL_sensor_to_camera_para(void)
{
    /* No use for YUV sensor */
}   /* sensor_to_camera_para */

/* ------------------------Engineer mode--------------------------------- */
/********************************************************
*   Engineer mode is unnecessary for YUV sensor driver  *
********************************************************/


/*****************************************************************************
 * FUNCTION
 *  get_sensor_group_count
 * DESCRIPTION
 *  
 * PARAMETERS
 *  pGroupCount     [?]     
 * RETURNS
 *  void
 *****************************************************************************/
void SP0827_SERIAL_get_sensor_group_count(kal_int32 *pGroupCount)
{
    /* No use for YUV sensor */
}


/*****************************************************************************
 * FUNCTION
 *  get_sensor_group_info
 * DESCRIPTION
 *  
 * PARAMETERS
 *  group_idx           [IN]        
 *  group_name_ptr      [?]         
 *  item_count_ptr      [?]         
 * RETURNS
 *  void
 *****************************************************************************/
void SP0827_SERIAL_get_sensor_group_info(kal_uint16 group_idx, kal_int8 *group_name_ptr, kal_int32 *item_count_ptr)
{
    /* No use for YUV sensor */
}


/*****************************************************************************
 * FUNCTION
 *  get_sensor_item_info
 * DESCRIPTION
 *  
 * PARAMETERS
 *  group_idx       [IN]        
 *  item_idx        [IN]        
 *  info_ptr        [?]         
 * RETURNS
 *  void
 *****************************************************************************/
void SP0827_SERIAL_get_sensor_item_info(kal_uint16 group_idx, kal_uint16 item_idx, ENG_sensor_info *info_ptr)
{
    /* No use for YUV sensor */
}


/*****************************************************************************
 * FUNCTION
 *  set_sensor_item_info
 * DESCRIPTION
 *  
 * PARAMETERS
 *  group_idx       [IN]        
 *  item_idx        [IN]        
 *  item_value      [IN]        
 * RETURNS
 *  
 *****************************************************************************/
kal_bool SP0827_SERIAL_set_sensor_item_info(kal_uint16 group_idx, kal_uint16 item_idx, kal_int32 item_value)
{
    /* No use for YUV sensor */
    return KAL_TRUE;
}

void SP0827_SERIAL_get_sensor_prefix_name(kal_char* buf){
    strcpy(buf, "SP0827_SERIAL");
}

#if (defined(DRV_ISP_6238_SERIES))
void  SP0827_SERIAL_dispatch_camera_info(void) {
       kal_mem_cpy(&dsc_support_info, &SP0827_SERIAL_dsc_support_info, sizeof(camcorder_info_struct));	
}
#endif

kal_uint32 SP0827_SERIAL_get_valid_camera_type(void) {
#if(defined(SP0827_SERIAL_YUV_MAIN))
    return  IMAGE_SENSOR_MAIN; 
#elif(defined(SP0827_SERIAL_YUV_SUB))
    return  IMAGE_SENSOR_SUB; 
#elif(defined(SP0827_SERIAL_YUV_BAK1))
    return  IMAGE_SENSOR_BAK1; 
#elif(defined(SP0827_SERIAL_YUV_SUB_BAK1))
    return  IMAGE_SENSOR_SUB_BAK1;
#endif 

}




