/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   usbvideo_attr.c
 *
 * Project:
 * --------
 *   Maui_Software
 *
 * Description:
 * ------------
 *   Camera Parameter for Webcam attribute define
 *
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
 
#include "kal_non_specific_general_types.h"
#include "kal_release.h"
#include "drv_features.h"
#include "med_api.h"
#include "isp_if.h"
#include "usbvideo_custom.h"
 
#if (defined(WEBCAM_SUPPORT))
#include "jpeg_enum.h"
#include "usbvideo_cam_if.h"
#include "usbvideo_attr_SP0827_SERIAL.h"

/* supported feature list */
const USBVideo_Attr_Info SP0827_SERIAL_ATTR_INFO[11] =
{
	{USBVIDEO_ATTRIBUTE_BRIGHTNESS, KAL_TRUE, KAL_TRUE},
	{USBVIDEO_ATTRIBUTE_CONTRAST, KAL_TRUE, KAL_TRUE},
	{USBVIDEO_ATTRIBUTE_HUE, KAL_TRUE, KAL_TRUE},	
	{USBVIDEO_ATTRIBUTE_HUE_AUTO, KAL_TRUE, KAL_TRUE},		
	{USBVIDEO_ATTRIBUTE_SATURATION, KAL_TRUE, KAL_TRUE},		
	{USBVIDEO_ATTRIBUTE_POWER_LINE_FREQUENCY, KAL_TRUE, KAL_TRUE},						
	{USBVIDEO_ATTRIBUTE_SHARPNESS, KAL_TRUE, KAL_TRUE},			
	{USBVIDEO_ATTRIBUTE_BACKLIGHT_COMPENSATION, KAL_TRUE, KAL_TRUE},				
	{USBVIDEO_ATTRIBUTE_GAMMA, KAL_TRUE, KAL_TRUE},								
	{USBVIDEO_ATTRIBUTE_WHITE_BALANCE_TMP, KAL_TRUE, KAL_TRUE},							
	{USBVIDEO_ATTRIBUTE_WHITE_BALANCE_TMP_AUTO, KAL_TRUE, KAL_TRUE},									
};

/* supported video size list */
const USBVideo_Video_Size_Info SP0827_SERIAL_VIDEO_SIZE[3] =
{
	{USBVIDEO_VIDEO_SIZE_1, 160, 120, 0xC000, 912382, 38012, 500000, 500000, 500000, 0},
	{USBVIDEO_VIDEO_SIZE_2, 320, 240, 0xC000, 912384, 38016, 500000, 500000, 500000, 0},
	
#if (defined(DRV_ISP_6238_SERIES))	
	{USBVIDEO_VIDEO_SIZE_3, 640, 480, 0x18000, 912384, 38016, 500000, 500000, 500000, 0}	
#else
	{USBVIDEO_VIDEO_SIZE_3, 640, 480, 0xC000, 912384, 38016, 500000, 500000, 500000, 0}	
#endif
};

/* supported still image size list */
const USBVideo_Still_Size_Info SP0827_SERIAL_STILL_SIZE[3] =
{
	{USBVIDEO_STILL_SIZE_1, 160, 120, 0xC000},
	{USBVIDEO_STILL_SIZE_2, 320, 240, 0xC000},
	
#if (defined(DRV_ISP_6238_SERIES))	
	{USBVIDEO_STILL_SIZE_3, 640, 480, 0x18000}
#else
	{USBVIDEO_STILL_SIZE_3, 640, 480, 0xC000}
#endif
};

/* supported compression type list*/
const USBVideo_Compression_Info SP0827_SERIAL_STILL_COMPRESSION[2] =
{
	{USBVIDEO_COMPRESSION_1, JPEG_ENCODE_QUALITY_LOW},
	{USBVIDEO_COMPRESSION_2, JPEG_ENCODE_QUALITY_FAIR}
};
const USBVIDEO_VIDEO_SIZE_TYPE SP0827_SERIAL_g_default_video_size = USBVIDEO_VIDEO_SIZE_1;
const USBVIDEO_STILL_SIZE_TYPE SP0827_SERIAL_g_default_still_size = USBVIDEO_STILL_SIZE_1;
const USBVIDEO_COMPRESSION_TYPE SP0827_SERIAL_g_default_compression = USBVIDEO_COMPRESSION_1;

/*************************************************************************
 * Customer Folder.. 
 *************************************************************************/
/*************************************************************************
* FUNCTION
*	usbvideo_camera_set_attr
*
* DESCRIPTION
*	This function set camera attr
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
/*void usbvideo_camera_set_attr(USBVideo_Attr_Value *attr)
{
	USBVIDEO_ATTRIBUTE_TYPE attr_type = attr->type;
	if(usbvideo_image_sensor_func==NULL)
	{
		usbvideo_camera_init();
		//ASSERT(0);
	}

	if(attr_type<=USBVIDEO_ATTRIBUTE_CT_MAX)
	{
		if( usbvideo_cam_command_CT_map[GET_ATTR_CT_IDX(attr_type)] == USBVIDEO_CAM_ATTR_FIX )
		{
				attr->value = 0;
		}
	}
	else
	{
		if( usbvideo_cam_command_PU_map[GET_ATTR_PU_IDX(attr_type)] == USBVIDEO_CAM_ATTR_FIX )
		{
			attr->value = 0;
		}
		else if( usbvideo_cam_command_PU_map[GET_ATTR_PU_IDX(attr_type)] == USBVIDEO_CAM_ATTR_SENSOR )
		{
			usbvideo_image_sensor_func->usbvideo_set_attr_value(attr);
		}
		else if( usbvideo_cam_command_PU_map[GET_ATTR_PU_IDX(attr_type)] == USBVIDEO_CAM_ATTR_ISP )
		{
			usbvideo_camera_effect_setting_attr(attr);	// ISP/IPP
		}
	}
}*/	/* usbvideo_camera_set_attr() */

/*void usbvideo_camera_get_attr(USBVideo_Attr_Value *attr)
{
	USBVIDEO_ATTRIBUTE_TYPE attr_type = attr->type;

	if(usbvideo_image_sensor_func==NULL)
	{
		usbvideo_camera_init();
		//ASSERT(0);
	}

	if(attr_type<=USBVIDEO_ATTRIBUTE_CT_MAX)
	{
	}
	else
	{
		if( usbvideo_cam_command_PU_map[GET_ATTR_PU_IDX(attr_type)] == USBVIDEO_CAM_ATTR_SENSOR )
		{
			usbvideo_image_sensor_func->usbvideo_get_attr_value(attr);
		}
		else if( usbvideo_cam_command_PU_map[GET_ATTR_PU_IDX(attr_type)] == USBVIDEO_CAM_ATTR_ISP )
		{
			usbvideo_camera_effect_getting_attr(attr);	// ISP/IPP
		}
	}
}*/

const USBVideo_Attr_Info* SP0827_SERIAL_get_usbvideo_attr_info(kal_uint8 *p_size)
{
	*p_size = sizeof(SP0827_SERIAL_ATTR_INFO)/sizeof(USBVideo_Attr_Info);
	return SP0827_SERIAL_ATTR_INFO;
}

const USBVideo_Video_Size_Info* SP0827_SERIAL_get_usbvideo_video_size(kal_uint8 *p_size)
{
	*p_size = sizeof(SP0827_SERIAL_VIDEO_SIZE)/sizeof(USBVideo_Video_Size_Info);
	return SP0827_SERIAL_VIDEO_SIZE;
}

const USBVIDEO_VIDEO_SIZE_TYPE SP0827_SERIAL_get_usbvideo_default_video_index(void)
{
	return SP0827_SERIAL_g_default_video_size;
}

const USBVideo_Still_Size_Info* SP0827_SERIAL_get_usbvideo_still_size(kal_uint8 *p_size)
{
	*p_size = sizeof(SP0827_SERIAL_STILL_SIZE)/sizeof(USBVideo_Still_Size_Info);
	return SP0827_SERIAL_STILL_SIZE;
}

const USBVIDEO_STILL_SIZE_TYPE SP0827_SERIAL_get_usbvideo_default_still_index(void)
{
	return SP0827_SERIAL_g_default_still_size;
}

const USBVideo_Compression_Info* SP0827_SERIAL_get_usbvideo_compression(kal_uint8 *p_size)
{
	*p_size = sizeof(SP0827_SERIAL_STILL_COMPRESSION)/sizeof(USBVideo_Compression_Info);
	return SP0827_SERIAL_STILL_COMPRESSION;
}

const USBVIDEO_COMPRESSION_TYPE SP0827_SERIAL_get_usbvideo_default_compression_index(void)
{
	return SP0827_SERIAL_g_default_compression;
}

/* function tables for USB driver*/
USBVideo_Camera_Param SP0827_SERIAL_usbvideo_cam_get_param_ISP =
{
	SP0827_SERIAL_get_usbvideo_attr_info,
	SP0827_SERIAL_get_usbvideo_video_size,
	SP0827_SERIAL_get_usbvideo_default_video_index,
	SP0827_SERIAL_get_usbvideo_still_size,
	SP0827_SERIAL_get_usbvideo_default_still_index,
	SP0827_SERIAL_get_usbvideo_compression,
	SP0827_SERIAL_get_usbvideo_default_compression_index,
	usbvideo_camera_get_attr
};

const USBVideo_Camera_Param* SP0827_SERIAL_USBVideo_Get_Camera_Param(void)
{
	return(&SP0827_SERIAL_usbvideo_cam_get_param_ISP);
}

/*************************************************************************
 * Customer Folder.. (Webcam Function Map)
 *************************************************************************/
/* translate the preivious infomrations into functions */
void SP0827_SERIAL_usbvideo_cmd_mapping(void)
{
	/* PU Part */
	kal_uint32 i;
	for(i=0;i<(sizeof(SP0827_SERIAL_ATTR_INFO)/sizeof(USBVideo_Attr_Info));i++)
	{
		usbvideo_cam_command_PU_map[GET_ATTR_PU_IDX(SP0827_SERIAL_ATTR_INFO[i].type)] = USBVIDEO_CAM_ATTR_ISP;
	}
	/* Sensor Attributes Part */
	/* NONE */
}

void SP0827_SERIAL_usbvideo_get_attr(USBVideo_Attr_Value *attr)
{
	/* Sensor Attributes Get */	
	/* NONE */	
	return;
}

void SP0827_SERIAL_usbvideo_set_attr(USBVideo_Attr_Value *attr)
{
	/* Sensor Attributes Set */	
	/* NONE */	
	return;
}

/* function tables for media task */
usbvideo_sensor_func_struct SP0827_SERIAL_usbvideo_func=
{
	SP0827_SERIAL_usbvideo_cmd_mapping,
	SP0827_SERIAL_usbvideo_get_attr,
	SP0827_SERIAL_usbvideo_set_attr
};

void SP0827_SERIAL_usbvideo_camera_func_config(void)
{
	usbvideo_image_sensor_func = &SP0827_SERIAL_usbvideo_func;
}

void SP0827_SERIAL_dispatch_usbvideo_info(void) 
{
        kal_mem_cpy(VIDEO_SIZE, SP0827_SERIAL_VIDEO_SIZE, sizeof(SP0827_SERIAL_VIDEO_SIZE));
        kal_mem_cpy(STILL_SIZE, SP0827_SERIAL_STILL_SIZE, sizeof(SP0827_SERIAL_STILL_SIZE));
        kal_mem_cpy(STILL_COMPRESSION, SP0827_SERIAL_STILL_COMPRESSION, sizeof(SP0827_SERIAL_STILL_COMPRESSION));
        g_default_video_size = SP0827_SERIAL_g_default_video_size;
        g_default_still_size = SP0827_SERIAL_g_default_still_size;
        g_default_compression = SP0827_SERIAL_g_default_compression;
}
#else

const USBVideo_Camera_Param* SP0827_SERIAL_USBVideo_Get_Camera_Param(void){}

void SP0827_SERIAL_usbvideo_camera_func_config(void){}
void SP0827_SERIAL_dispatch_usbvideo_info(void){}


#endif	// END_OF_WEBCAM_SUPPORT
