/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor.h
 *
 * Project:
 * --------
 *   Maui_sw
 *
 * Description:
 * ------------
 *   Image sensor header file
 *
 * Author:
 * -------
 * -------
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#ifndef _IMAGE_SENSOR_SP0829_SERIAL_H
	#define _IMAGE_SENSOR_SP0829_SERIAL_H

	#include "kal_non_specific_general_types.h"
	#include "drv_features.h"
	#include "isp_if.h"
	#include "sensor_struct.h"
	#include "image_sensor.h"

//------------------------Engineer mode---------------------------------
#if (!(defined(DRV_ISP_6238_SERIES) ||defined(DRV_ISP_6235_SERIES) ))
#if (!(defined(__CAMERA_NVRAM_REDUCTION__) && defined(DRV_ISP_6225_SERIES)))
#define SP0829_SERIAL_FACTORY_START_ADDR (70)

typedef enum SP0829_SERIAL_group_enum {
    SP0829_SERIAL_AWB_GAIN = 0,
    SP0829_SERIAL_PRE_GAIN,
    SP0829_SERIAL_SENSOR_DBLC,
    SP0829_SERIAL_GAMMA_ENABLE,
    SP0829_SERIAL_CMMCLK_CURRENT,
    SP0829_SERIAL_FRAME_RATE_LIMITATION,
    SP0829_SERIAL_REGISTER_EDITOR,
    SP0829_SERIAL_GROUP_TOTAL_NUMS
} SP0829_SERIAL_FACTORY_CCT_GROUP_ENUM;

typedef enum SP0829_SERIAL_register_index {
   SP0829_SERIAL_AWB_GAIN_R_INDEX=SP0829_SERIAL_FACTORY_START_ADDR,
   SP0829_SERIAL_AWB_GAIN_B_INDEX,
   SP0829_SERIAL_SENSOR_DBLC_INDEX,
   SP0829_SERIAL_GAMMA_ENABLE_INDEX,
   SP0829_SERIAL_CMMCLK_CURRENT_INDEX,
   SP0829_SERIAL_FACTORY_END_ADDR
} SP0829_SERIAL_FACTORY_REGISTER_INDEX;

typedef enum SP0829_SERIAL_cct_register_index {
   SP0829_SERIAL_GLOBAL_GAIN_INDEX = 0,
   SP0829_SERIAL_PRE_GAIN_R_INDEX,
   SP0829_SERIAL_PRE_GAIN_B_INDEX,
   SP0829_SERIAL_CCT_END_ADDR
} SP0829_SERIAL_CCT_REGISTER_INDEX; 

typedef struct {
	sensor_reg_struct reg[SP0829_SERIAL_FACTORY_END_ADDR];
	sensor_reg_struct cct[SP0829_SERIAL_CCT_END_ADDR];
} sensor_data_struct;
#endif
#endif	

// Prototypes FOR ENGINEER FACTORY MODE
void  SP0829_SERIAL_get_sensor_group_count(kal_int32* sensor_count_ptr);
void  SP0829_SERIAL_get_sensor_group_info(kal_uint16 group_idx, kal_int8* group_name_ptr, kal_int32* item_count_ptr);
void  SP0829_SERIAL_get_sensor_item_info(kal_uint16 group_idx,kal_uint16 item_idx, ENG_sensor_info* info_ptr);
kal_bool SP0829_SERIAL_set_sensor_item_info(kal_uint16 group_idx, kal_uint16 item_idx, kal_int32 item_value);

//------------------------Engineer mode---------------------------------
// write camera_para to sensor register 
void SP0829_SERIAL_camera_para_to_sensor(void);
// update camera_para from sensor register 
void SP0829_SERIAL_sensor_to_camera_para(void);
// config sensor callback function 
void SP0829_SERIAL_image_sensor_func_config(void);
// detect sensor id
kal_uint32 SP0829_SERIAL_detect_sensor_id(void);

void SP0829_SERIAL_get_sensor_prefix_name(kal_char* buf);
void  SP0829_SERIAL_dispatch_camera_info(void);
kal_uint32 SP0829_SERIAL_get_valid_camera_type(void);


/* MAXIMUM EXPLOSURE LINES USED BY AE */
extern kal_uint16 SP0829_SERIAL_MAX_EXPOSURE_LINES;   // must be defined but not referenced by YUV driver
extern kal_uint8  SP0829_SERIAL_MIN_EXPOSURE_LINES;   // must be defined but not referenced by YUV driver

#if (defined(SP0829_SERIAL_YUV_MAIN)||defined(SP0829_SERIAL_YUV_BAK1))
// BB's reset pin high low control MACROs
#define SP0829_SERIAL_RESET_PIN_LOW   (REG_ISP_CMOS_SENSOR_MODE_CONFIG &= ~REG_CMOS_SENSOR_RESET_BIT)
#define SP0829_SERIAL_RESET_PIN_HIGH  (REG_ISP_CMOS_SENSOR_MODE_CONFIG |= REG_CMOS_SENSOR_RESET_BIT)

#define SP0829_SERIAL_PWRDN_PIN_LOW           (REG_ISP_CMOS_SENSOR_MODE_CONFIG &= ~REG_CMOS_SENSOR_POWER_ON_BIT)
#define SP0829_SERIAL_PWRDN_PIN_HIGH          (REG_ISP_CMOS_SENSOR_MODE_CONFIG |= REG_CMOS_SENSOR_POWER_ON_BIT)
#else
#define SP0829_SERIAL_RESET_PIN_LOW   
#define SP0829_SERIAL_RESET_PIN_HIGH  

#define SP0829_SERIAL_PWRDN_PIN_LOW   
#define SP0829_SERIAL_PWRDN_PIN_HIGH  
#endif

// sensor's chip ID and version
#define SP0829_SERIAL_SENSOR_VERSION              (0x11)

// sensor's I2C read/write IDs    
#define SP0829_SERIAL_I2C_WRITE_ID               0x86// (0x62)//(0x66)
#define SP0829_SERIAL_I2C_READ_ID                 0x87//(0x63)//(0x67)
   
//#define SP0829_SERIAL_HW_SCCB /* if no define, means use SW SCCB *///cjl
    
    /* I2C FAIL TRY NUMBER */
#define SP0829_SERIAL_MAX_I2C_FAIL_TRY_NO     5
    
    /* SENSOR I2C DELAY*/
#define SP0829_SERIAL_SENSOR_I2C_DELAY        0xE0

#ifdef SP0829_SERIAL_HW_SCCB

    
#define SP0829_SERIAL_I2C_START_TRANSMISSION \
    { \
        volatile kal_uint32 j; \
        SET_SCCB_CLK_OUTPUT; \
        SET_SCCB_DATA_OUTPUT; \
        SET_SCCB_DATA_HIGH; \
        for (j = SP0829_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); \
        SET_SCCB_CLK_HIGH; \
        for (j = SP0829_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); \
        SET_SCCB_DATA_LOW; \
        for (j = SP0829_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); \
        SET_SCCB_CLK_LOW; \
        for (j = SP0829_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); \
    }
    
#define SP0829_SERIAL_I2C_STOP_TRANSMISSION \
    { \
        volatile kal_uint32 j; \
        SET_SCCB_CLK_OUTPUT; \
        SET_SCCB_DATA_OUTPUT; \
        SET_SCCB_CLK_LOW; \
        SET_SCCB_DATA_LOW; \
        for (j = SP0829_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); \
        SET_SCCB_CLK_HIGH; \
        for (j = SP0829_SERIAL_SENSOR_I2C_DELAY; j > 0; j--); \
        SET_SCCB_DATA_HIGH; \
    }
#endif

/* sensor size */
#define SP0829_SERIAL_IMAGE_SENSOR_QVGA_WIDTH     (240) //    (352)   //    
#define SP0829_SERIAL_IMAGE_SENSOR_QVGA_HEIGHT     (320) //   (288)   //   

#define SP0829_SERIAL_IMAGE_SENSOR_QCIF_WIDTH                (176) 
#define SP0829_SERIAL_IMAGE_SENSOR_QCIF_HEIGHT               (144)

/* SENSOR PIXEL/LINE NUMBERS IN ONE PERIOD */
#define SP0829_SERIAL_PERIOD_PIXEL_NUMS          (364 + 117 + 8)/* Active + HST + HFT */
#define SP0829_SERIAL_PERIOD_LINE_NUMS           (300 + 8)      /* Active + 9 */

#define SP0829_SERIAL_BLANK_REGISTER_LIMITATION   0xFFF


/* FRAME RATE UNIT */
#define SP0829_SERIAL_FRAME_RATE_UNIT               10

/* MAX CAMERA FRAME RATE */
#if !defined(MT6225)
#define SP0829_SERIAL_MAX_CAMERA_FPS         (SP0829_SERIAL_FRAME_RATE_UNIT * 30)
#else
#define SP0829_SERIAL_MAX_CAMERA_FPS         (SP0829_SERIAL_FRAME_RATE_UNIT * 20)
#endif

extern MM_ERROR_CODE_ENUM SP0829_SERIAL_set_interface_info(kal_uint8 *para_out);
extern MM_ERROR_CODE_ENUM SP0829_SERIAL_get_interface_info(kal_uint8 *para_out);


#endif 
