/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor.c
 *
 * Project:
 * --------
 *   Maui_sw
 *
 * Description:
 * ------------
 *   Image sensor driver function
 *
 * Author:
 * -------
 * -------
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#include "drv_features.h"

#if (defined(DRV_ISP_6235_SERIES) && defined(DRV_ISP_MT6252_HW_SUPPORT))

#include "kal_non_specific_general_types.h"
#include "sensor_common_interface.h"

static kal_uint32	SP0827_SERIAL_sensor_valid_width	= 320;
static kal_uint32	SP0827_SERIAL_sensor_valid_height 	= 240;
static kal_bool		SP0827_SERIAL_sensor_pclk_inv = KAL_TRUE;

MM_ERROR_CODE_ENUM SP0827_SERIAL_set_interface_info(kal_uint8 *para_in)
{
	/* sensor_sec_info_struct */
	PSEC_SENSOR_SET_PARA_STRUCT p_input_para = (PSEC_SENSOR_SET_PARA_STRUCT)para_in;

	SP0827_SERIAL_sensor_pclk_inv			= p_input_para->sensor_pclk_inv;
	SP0827_SERIAL_sensor_valid_width		= p_input_para->sensor_valid_width;
	SP0827_SERIAL_sensor_valid_height 		= p_input_para->sensor_valid_height;
	
	return ERROR_NONE;	
}

MM_ERROR_CODE_ENUM SP0827_SERIAL_get_interface_info(kal_uint8 *para_out)
{
	PSERIAL_SENSOR_INTERFACE_STRUCT p_serial_sensor_para = (PSERIAL_SENSOR_INTERFACE_STRUCT)para_out;

        p_serial_sensor_para->para_1 = SP0827_SERIAL_sensor_pclk_inv;//KAL_TRUE; //PAD2CAM_CLK_INV
        p_serial_sensor_para->para_2 = 4; //
        p_serial_sensor_para->para_3 = SP0827_SERIAL_sensor_valid_width;//352; //width
        p_serial_sensor_para->para_4 = SP0827_SERIAL_sensor_valid_height;//288; //height

	return ERROR_NONE;
}

/* serial support */
#endif


