// Here is where all the model specific defines should be


#include "hal_i2c.h"
#include "hal_camera.h"
#include "camera_m.h"

//#define  DRV_CAM_FRAME_6    1
#define  DRV_CAM_FRAME_10    1
//#define  DRV_CAM_FRAME_12    1

// 1 - yuv
// 0 - RGB565
#define YUV_OUTPUT  1
//#define YUV_OUTPUT  0

typedef struct
{
    UINT8 Addr;            // Register Address
    UINT8 Data;             // Register Data
    UINT8 Wait;            // Time to wait after write
} CAM_REG_T;

typedef struct
{
    UINT16 Len;             // Size of array
    CAM_REG_T *RegVal;      // Array of registers
} CAM_REG_GROUP_T;

typedef enum
{
    CAM_MODE_IDLE,
    CAM_MODE_PREVIEW_STAGE_1,
    CAM_MODE_PREVIEW_STAGE_2,
    CAM_MODE_CAPTURE_STAGE_1,
    CAM_MODE_CAPTURE_STAGE_2,
    CAM_MODE_PREP_VID_CAPTURE,
    CAM_MODE_VID_CAPTURE
} CAM_MODE_T;

// On FPGA platform, Pixel Clock must not be too fast or xfer screws up
#define CAM_CLK_CFG 0x81

/*/ change teh clk 
{0xfa, 0x10},
{0xfe, 0x02},
{0x04, 0x21},
{0xfe, 0x00}
*/

// use this for 320x240 (VGA) capture
/*sp0827*/
#define REG90 0x50
#define REG93 0x4c
#define REG94 0x44
#define REG8f 0x40
#define REG92 0x50
#define REG95 0x4c
#define REG96 0x44
#define REG91 0x40


// 128 * 160, for camera preview
PRIVATE const CAM_REG_T RG_Reinit_QQVGA[] = 
{
 //SP0829 д   
};

// 320 * 240, for capture
PRIVATE const CAM_REG_T RG_Reinit_QVGA[] = 
{
 //SP0829 д      
};

// specific to video recorder, 160*120
PRIVATE const CAM_REG_T RG_Reinit_QQVGA_2[] = 
{
 //SP0829 д     
};


unsigned char Dual_Camera_SP0827_CONFIG_2BIT[] =
{                                           
	0x1c , 0x00,                              
	0x30 , 0x06,                              
	0x27 , 0x38,                              
	0x28 , 0x0b,                              
	0xe7 , 0x03,                              
	0xe7 , 0x00,                              

	0x32 , 0x00,                              
	0x03 , 0x01,                              
	0x04 , 0x90,                              
	0x24 , 0x2a, 
	0x0e , 0x00,
	                                       
	//analog  for 2bit                         
	0x0f , 0x0c,                             
	0x10 , 0x0c,                             
	0x12 , 0x0a,                             
	0x13 , 0x06,                             
	0x14 , 0x00,                             
	0x15 , 0x04,                             
	0x16 , 0x00,                             
	0x17 , 0x01,                             
	0x18 , 0x00,                             
	0x1a , 0x0f,                             
	                                       
	//AE  19.5M 4Ƶ for 2bit 14-8fps           
	//ae setting                                                            
	0x06 , 0x0 ,                             
	0x09 , 0x01,                             
	0x0a , 0x07,                             
	//base                                     
	0x97 , 0x2f,                             
	0x98 , 0x0 ,                             
	//exp                                      
	0x70 , 0x34,                             
	0x71 , 0x02,                             
	0x72 , 0x2f,                             
	0x73 , 0x0 ,                             
	0x78 , 0x2f,                             
	0x79 , 0x0 ,                             
	0x7a , 0x1 ,                             
	0x7b , 0x0 ,                             
	//gain                                     
	0x74 , 0x70,                             
	0x75 , 0x2a,                             
	0x7c , 0x50,                             
	0x7d , 0x2a,                             
	0x80 , 0x50,                             
	0x81 , 0x3e,                             
	0x82 , 0x36,                             
	0x83 , 0x30,                             
	0x84 , 0x30,                             
	0x85 , 0x2e,                             
	0x86 , 0x2e,                             
	0x87 , 0x2c,                             
	0x88 , 0x2c,                             
	0x89 , 0x2c,                             
	0x8a , 0x2a,                             
	0x8b , 0x2a,                             
	0x8c , 0x2a,                             
	//target                                   
	0x90 , 0x50, //indoor hold               
	0x93 , 0x4c,	//idoor lock               
	0x94 , 0x44,                             
	0x8f , 0x40,                             
	0x92 , 0x50,	//otdoor hold              
	0x95 , 0x4c,	//otdoor lock              
	0x96 , 0x44,                             
	0x91 , 0x40,                             
	                                       
	//Status                                                                
	0x60 , 0x40,//mean_nr_dummy              
	0x61 , 0x50,//mean_dummy_nr              
	0x62 , 0x20,//mean_dummy_low             
	0x63 , 0x35,//mean_low_dummy             
	0x64 , 0x70,//rpc_heq_low                
	0x65 , 0x70,//rpc_heq_dummy              
	0x66 , 0x34,//exp_heq_dummy_8lsm         
	0x67 , 0x02,//exp_heq_dummy_5hsm         
	0x68 , 0x34,//exp_heq_low_8lsm           
	0x69 , 0x02,//exp_heq_low_5hsm           
	                                       
	0x99 , 0x09,                             
	0x32 , 0x05,                             
	                                       
};

unsigned char Dual_Camera_SP0829_CONFIG_2BIT[] =
{ 
	//26M 2bit                                            
	                                   
	0x1c,0x00,			                                           
	//spi		                                                       
	//0x2e,0x71,	//d0->d7
	0x2e,0xd1,	//d7->d0
	0x2c,0x08,
	0x2b,0x0a,
	0x2d,0x40,
	0x30,0x04,
	0x31,0x00,

	0x0e,0xf7,
#if 1// YUV_OUTPUT
	// YUV
	0x35, 0x00,
	0x3f, 0x00,
#else
	// RGB565
	0x35,0x04,
	0x3f, 0x01, 
#endif

	//pregain	                                                     
	0x4b,0x0c,                                                   
	0x4c,0x0c,                                                   
	0x4d,0x0c,                                                   
	0x4e,0x0c,                                                   

	//AWB	                                                      
	0xc5,0xc4,                                                   
	0xc6,0x9f,     
	0xbe,0x20,                                               
	0xb3,0x7e,                                                   
	0xb5,0x10,                                               
	0xd4,0xff,                                               
	0xba,0x2d,                                                   
	0xd7,0x90,                                                   
	0xd8,0xa0,                                                   
	0xd9,0xff,                                                   
	0xdd,0xa6,                                                   
	0xe1,0xc7,                                                   
	0xe3,0xd0,                                                   
	0xd5,0xe0,                                                   

	//smooth	                                                     
	0x42,0x54,    	                                           
	0x46,0x0a,    	                                           

	//sharpen		                                                   
	0x50,0x40,    	                                           
	0x51,0x10,    	                                           
	0x52,0xe0,   
	0x55,0x10, 	                                           
	0x56,0x30,  	                                           
	0x57,0x20,                                               
	//color ƫ                                               
	0x79,0xb1,                                               
	0x7a,0xcf,                                               
	0x7b,0x00,                                               
	0x7c,0x19,                                               
	0x7d,0x70,                                               
	0x7e,0xf7,                                               
	0x7f,0x18,                                               
	0x80,0xc1,                                               
	0x81,0xa6,                                               
	0x82,0x0c,                                               
	0x83,0x30,                                               
	0x84,0x0c,  
	//sat                                             
	0x4f,0x60,			                                           
	0x58,0xff,			                                           
	0x59,0xff,

	//heq                                             
	0x5b,0x80,			                                           
	0x5c,0xa0,

	//auto lum lowlight 		                                       
	0x86,0x30,			                                           
	0x87,0x1f,			                                           
	0x88,0x30,			                                           
	0x89,0x45,                                                 
                                       
	//gama                                                       
	0x65,0x0 ,                                                 
	0x66,0xa ,                                                 
	0x67,0x13,                                                 
	0x68,0x25,                                                 
	0x69,0x43,                                                 
	0x6a,0x5d,                                                 
	0x6b,0x74,                                                 
	0x6c,0x88,                                                 
	0x6d,0x9a,                                                 
	0x6e,0xa9,                                                 
	0x6f,0xb5,                                                 
	0x70,0xc0,                                                 
	0x71,0xca,                                                 
	0x72,0xd4,                                                 
	0x73,0xdd,                                                 
	0x74,0xe6,                                                 
	0x75,0xef,                                                 
	0x76,0xf7,                                                 
	0x77,0xff,      
	
	0x33,0x0f,		                                             
	0x34,0x06,		                                             
	0x32,0x08,                                                 
	0xff,0xff,   
	                   
};

unsigned char Dual_Camera_SP0827_CONFIG_1BIT[] =
{                                           
	 0x1c , 0x00,                              
	 0x30 , 0x16,                              
	 0x27 , 0x38,                              
	 0x28 , 0x0b,                              
	 0xe7 , 0x03,                              
	 0xe7 , 0x00,                              
	 
	 0x32 , 0x00,                              
	 0x03 , 0x01,                              
	 0x04 , 0x90,                              
	 0x24 , 0x2a, 
	 0x0e , 0x00,
	                                           
	//analog  for 1bit                         
	  0x0f , 0x06,                             
	  0x10 , 0x06,                             
	  0x12 , 0x05,                             
	  0x13 , 0x03,                             
	  0x14 , 0x00,                             
	  0x15 , 0x02,                             
	  0x16 , 0x00,                             
	  0x17 , 0x01,                             
	  0x18 , 0x00,                             
	  0x1a , 0x0f,                             
	                                           
	//AE  19.5M 8Ƶ for 1bit 12-8fps           
	//ae setting                                                            
	  0x06 , 0x0 ,                             
	  0x09 , 0x00,                             
	  0x0a , 0x29,                             
	//base                                     
	  0x97 , 0x29,                             
	  0x98 , 0x0 ,                             
	//exp                                      
	  0x70 , 0xec,                             
	  0x71 , 0x01,                             
	  0x72 , 0x29,                             
	  0x73 , 0x0 ,                             
	  0x78 , 0x29,                             
	  0x79 , 0x0 ,                             
	  0x7a , 0x1 ,                             
	  0x7b , 0x0 ,                             
	//gain                                     
	  0x74 , 0x70,                             
	  0x75 , 0x2a,                             
	  0x7c , 0x50,                             
	  0x7d , 0x2a,                             
	  0x80 , 0x50,                             
	  0x81 , 0x3e,                             
	  0x82 , 0x36,                             
	  0x83 , 0x30,                             
	  0x84 , 0x30,                             
	  0x85 , 0x2e,                             
	  0x86 , 0x2e,                             
	  0x87 , 0x2c,                             
	  0x88 , 0x2c,                             
	  0x89 , 0x2c,                             
	  0x8a , 0x2a,                             
	  0x8b , 0x2a,                             
	  0x8c , 0x2a,                             
	//target                                   
	  0x90 , 0x50, //indoor hold               
	  0x93 , 0x4c,	//idoor lock               
	  0x94 , 0x44,                             
	  0x8f , 0x40,                             
	  0x92 , 0x50,	//otdoor hold              
	  0x95 , 0x4c,	//otdoor lock              
	  0x96 , 0x44,                             
	  0x91 , 0x40,                             
	                                           
	//Status                                                                
	  0x60 , 0x40,//mean_nr_dummy              
	  0x61 , 0x50,//mean_dummy_nr              
	  0x62 , 0x20,//mean_dummy_low             
	  0x63 , 0x35,//mean_low_dummy             
	  0x64 , 0x70,//rpc_heq_low                
	  0x65 , 0x70,//rpc_heq_dummy              
	  0x66 , 0xec,//exp_heq_dummy_8lsm         
	  0x67 , 0x01,//exp_heq_dummy_5hsm         
	  0x68 , 0xec,//exp_heq_low_8lsm           
	  0x69 , 0x01,//exp_heq_low_5hsm           
	                                           
	  0x99 , 0x09,                             
	  0x32 , 0x05,                             
	                                           
};

unsigned char Dual_Camera_SP0829_CONFIG_1BIT[] =
{ 
	//26M 2bit                                            
	                                       
	0x1c,0x00,			                                           

	0x2e,0xd0,	//d7->d0
	0x2c,0x01,
	0x2b,0x0a,
	0x2d,0x40,
	0x30,0x06,
	0x31,0x00,

	0x0e,0xf7,
#if 1// YUV_OUTPUT
	// YUV
	0x35, 0x00,
	0x3f, 0x00,
#else
	// RGB565
	0x35,0x04,
	0x3f, 0x01, 
#endif
	//pregain	                                                     
	0x4b,0x0c,                                                   
	0x4c,0x0c,                                                   
	0x4d,0x0c,                                                   
	0x4e,0x0c,                                                   

	//AWB	                                                      
	0xc5,0xc4,                                                   
	0xc6,0x9f,  
	0xbe,0x20,                                                 
	0xb3,0x7e,                                                   
	0xb5,0x10,                                               
	0xd4,0xff,                                               
	0xba,0x2d,                                                   
	0xd7,0x90,                                                   
	0xd8,0xa0,                                                   
	0xd9,0xff,                                                   
	0xdd,0xa6,                                                   
	0xe1,0xc7,                                                   
	0xe3,0xd0,                                                   
	0xd5,0xe0,                                                   

	//smooth	                                                     
	0x42,0x54,    	                                           
	0x46,0x0a,    	                                           

	//sharpen		                                                   
	0x50,0x40,    	                                           
	0x51,0x10,    	                                           
	0x52,0xe0, 
	0x55,0x10,   	                                           
	0x56,0x30,  	                                           
	0x57,0x20,                                               
	//color                                               
	0x79,0xb1,                                               
	0x7a,0xcf,                                               
	0x7b,0x00,                                               
	0x7c,0x19,                                               
	0x7d,0x70,                                               
	0x7e,0xf7,                                               
	0x7f,0x18,                                               
	0x80,0xc1,                                               
	0x81,0xa6,                                               
	0x82,0x0c,                                               
	0x83,0x30,                                               
	0x84,0x0c,  
	//sat                                             
	0x4f,0x60,			                                           
	0x58,0xff,			                                           
	0x59,0xff,

	//heq                                             
	0x5b,0x80,			                                           
	0x5c,0xa0,

	//auto lum lowlight 		                                       
	0x86,0x30,			                                           
	0x87,0x1f,			                                           
	0x88,0x30,			                                           
	0x89,0x45,                                                                                         
	//gama                                                       
	0x65,0x0 ,                                                 
	0x66,0xa ,                                                 
	0x67,0x13,                                                 
	0x68,0x25,                                                 
	0x69,0x43,                                                 
	0x6a,0x5d,                                                 
	0x6b,0x74,                                                 
	0x6c,0x88,                                                 
	0x6d,0x9a,                                                 
	0x6e,0xa9,                                                 
	0x6f,0xb5,                                                 
	0x70,0xc0,                                                 
	0x71,0xca,                                                 
	0x72,0xd4,                                                 
	0x73,0xdd,                                                 
	0x74,0xe6,                                                 
	0x75,0xef,                                                 
	0x76,0xf7,                                                 
	0x77,0xff,                                                 
		                                             
	0x33,0x0f,		                                             
	0x34,0x06,		                                             
	0x32,0x08,                                                 
	0xff,0xff,   
	                    
};


#if 0
PRIVATE const CAM_REG_T RG_Reinit_SINGLE_WIRE[] = 
{
};

PRIVATE const CAM_REG_T RG_Reinit_DUAL_WIRE[] = 
{
};
#endif

PRIVATE const CAM_REG_T RG_Reinit_MODE_DEFAULT[] =
{
};

// use this for 640x480 (VGA) capture
PRIVATE const CAM_REG_T RG_InitPowerOnVga[] = 
{};


// use this for 160*120 (QQVGA) capture
PRIVATE const CAM_REG_T RG_InitPowerOnQqvga[] = 
{};

PRIVATE const CAM_REG_T RG_VidFormatVga[] = 
{
};

PRIVATE const CAM_REG_T RG_VidFormatQvga[] = 
{
};

PRIVATE const CAM_REG_T RG_VidFormatQqvga[] = 
{
#if !defined(VIDREC_FAST_RECORDING)
    // 19.5MHz 2bit fix10 fps 
{0x74 , 0x70,1},
{0x7c , 0x70,1},
{0x06 , 0x0 ,1},
{0x09 , 0x01,1},
{0x0a , 0xcd,1},
{0x97 , 0x22,1},
{0x98 , 0x0 ,1},
{0x70 , 0x54,1},
{0x71 , 0x01,1},
{0x72 , 0x22,1},
{0x73 , 0x00,1},
{0x78 , 0x22,1},
{0x79 , 0x0 ,1},
{0x7a , 0x01,1},
{0x7b , 0x00,1},
#else
    // 19.5MHz 2bit fix15 fps 
{0x74 , 0x70,1},
{0x7c , 0x70,1},
{0x06 , 0x0 ,1},
{0x09 , 0x00,1},
{0x0a , 0xde,1},
{0x97 , 0x33,1},
{0x98 , 0x0 ,1},
{0x70 , 0x32,1},
{0x71 , 0x01,1},
{0x72 , 0x33,1},
{0x73 , 0x00,1},
{0x78 , 0x33,1},
{0x79 , 0x0 ,1},
{0x7a , 0x01,1},
{0x7b , 0x00,1},
#endif
};

typedef struct
{
    // Camera information structure
    char                desc[40];	

    UINT8               snrtype;            //sensor type(RGB or YUV)
    UINT8               pclk;               //use PCLK of sensor
    UINT8               clkcfg;             //[0]: VSync delay enable; [1]: Fifo VSync delay enable; [2]: Use PCLK Negtive Edge.
    HAL_I2C_BPS_T       i2crate;            //I2C rate : KHz				
    UINT8               i2caddress;         //I2C address
    UINT8               i2cispaddress;      //ISP I2C address
    UINT8               pwrcfg;             //sensor power initial configure(SIF REG801 BIT[0]~BIT[2])
    BOOL                rstactiveh;         //sensor reset active hi/low polarity (TRUE = active hi)
    BOOL                snrrst;             //Reset sensor enable

    CAM_MODE_T          cammode;


    BOOL                capturevideo;
    BOOL                captureframe;
    UINT8               numactivebuffers;
    UINT8               currentbuf;

    UINT8               brightness;         //brightness
    UINT8               contrast;           //contrast

    CAM_FORMAT_T        format;
    UINT32              npixels;
    CAM_IMAGE_T         vidbuffer;

    CAM_REG_GROUP_T     standby;            //sensor standby register
    CAM_REG_GROUP_T     Initpoweron;        //SENSOR ISP initial configure

    CAM_REG_GROUP_T     sifpwronseq;        //Sif config sequence(Reg.800 bit0~2) when sensor power on
    CAM_REG_GROUP_T     sifstdbyseq;        //Sif config sequence(Reg.800 bit0~2) when sensor standby
    CAM_REG_GROUP_T     dsif;               //SIF initial configure
    //    TSnrSizeCfgGroup    snrSizeCfg;         //sensor size configure information

    // This 'callback' mechanism is not necessary because the encapsulation is taken
    // care of by the environment
    //    PSensorSetReg       snrSetRegCall;      //set reg callback
    //    PSensorGetReg       snrGetRegCall;
    //    PSnrIdChk           snrIdChkCall;
    //    PSnrMirrorFlip      snrMirrorFlipCall;
    //    PSnrContrast        snrContrastCall;
    //    PSnrBrightness      snrBrightnessCall;
    //    PSnrMode            snrModeCall;
    //    PSnrGetEt           snrGetEt;
    //    PSnrSetEt           snrSetEt;
    //    TFlashParm          flashparm;
    CAM_IRQ_HANDLER_T   camirqhandler;
} CAM_INFO_T;

PRIVATE volatile CAM_INFO_T gSensorInfo =
{
    "SP0827",      // char desc[40];	

    0,                      // UINT8 snrtype; (rgb)
    1,                      // UINT8 pclk; use or don't use PCLK of sensor???
    0,                      // UINT8 clkcfg; ???
    HAL_I2C_BPS_100K,       // UINT16 i2crate;
    0x40,                   // UINT8 i2caddress; this is the _REAL_ slave address.  
    //  The value written in phase 1 of a write cycle will be 0x42
    //  while the value just before the read will be 0x43
    0x40,                   // UINT8 i2cispaddress;
    0x02,                   // UINT8 pwrcfg;???
    TRUE,                   // BOOL rstactiveh;  // active high
    FALSE,                  // BOOL snrrst;

    CAM_MODE_IDLE,          // cammode

    FALSE,                  // Capture video mode
    FALSE,                  // Capturing single frame
    0,                      // Number of active buffers reserved by the upper layer
    0,                      // current frame buffer

    3,                      // UINT8 brightness;
    4,                      // UINT8 contrast;
    CAM_FORMAT_RGB565,      // Format
    CAM_NPIX_QVGA,           // npixels(VGA, QVGA, QQVGA...)
    NULL,                   // Video Buffer.  First frame buffer for video or image buffer

    {0, NULL},              // CAM_REG_GROUP_T standby;
    // Should start with QQVGA, but for testing, start with VGA
    //    {sizeof(RG_InitPowerOnQqvga) / sizeof(CAM_REG_T), (CAM_REG_T*)&RG_InitPowerOnQqvga}, // CAM_REG_GROUP_T Initpoweron;
    {sizeof(RG_InitPowerOnVga) / sizeof(CAM_REG_T), (CAM_REG_T*)&RG_InitPowerOnVga}, // CAM_REG_GROUP_T Initpoweron;

    {0, NULL},              // CAM_REG_GROUP_T sifpwronseq;
    {0, NULL},              // CAM_REG_GROUP_T sifstdbyseq;
    {0, NULL},              // CAM_REG_GROUP_T dsif; initial value
    NULL                    // IRQ Callback
};

// ############
// Private
// ############

// These are the commands specific to the SCCB
#define PHASE3_WR_PH1   0x11000     // Start & Write    Slave ID
#define PHASE3_WR_PH2   0x1000      // Write            Slave Register Address
#define PHASE3_WR_PH3   0x1100      // Stop & Write     Slave Register Data

#define PHASE2_WR_PH1   0x11000     // Start & Write    Slave ID
#define PHASE2_WR_PH2   0x1100      // Stop & Write     Slave Register Address (to read)

#define PHASE2_RD_PH1   0x11000     // Start & Write    Slave ID
#define PHASE2_RD_PH2   0x111       // Stop & Read & NACK   Slave Register Read Data

PRIVATE VOID camerap_WriteOneReg( UINT8 Addr, UINT8 Data);
PRIVATE VOID camerap_Delay(UINT16 Wait_mS);
PRIVATE VOID camerap_WriteReg(CAM_REG_T RegWrite);
PRIVATE UINT8 camerap_ReadReg(UINT8 Addr);
PRIVATE VOID camerap_SendRgSeq(const CAM_REG_T *RegList, UINT16 Len);
PRIVATE VOID camerap_InteruptHandler(HAL_CAMERA_IRQ_CAUSE_T cause);
PRIVATE UINT8 camerap_GetId(VOID);





